Package: libr
Type: Package
Title: Libraries, Data Dictionaries, and a Data Step for R
Version: 1.3.4
Author: David J. Bosak
Maintainer: David Bosak <dbosak01@gmail.com>
Description: Contains a set of functions to create data libraries,
    generate data dictionaries, and simulate a data step.
    The libname() function will load a directory of data into 
    a library in one line of code.  The dictionary() function
    will generate data dictionaries for individual
    data frames or an entire library.  And the datestep() function
    will perform row-by-row data processing.
License: CC0
Encoding: UTF-8
URL: https://libr.r-sassy.org, https://github.com/dbosak01/libr
BugReports: https://github.com/dbosak01/libr/issues
Depends: R (>= 3.6.0), common (>= 1.1.0)
Suggests: testthat, knitr, rmarkdown, foreign, magrittr, utils, logr,
        covr, fmtr
Imports: readr, readxl, haven, openxlsx, crayon, dplyr, tibble, tools,
        Rcpp, data.table
RoxygenNote: 7.3.1
VignetteBuilder: knitr
LinkingTo: Rcpp
Built: R 4.4.1; x86_64-apple-darwin24.0.0; 2024-10-20 08:37:43 UTC; unix

library(fmtr)

myfmt <- value(condition(x >= 20, "High"),
               condition(x < 20, "Low"))


d1 <- datastep(mtcars, {
  
  mpgcat <- fapply(mpg, myfmt)
  
})


d1


if (!"mpgcat" %in% names(d1))
  stop("Mpgcat missing")


if (d1$mpgcat[1] != "High")
  stop("Mpgcat value not High")

context("Manipulation Tests")

base_path <- "c:\\packages\\libr\\tests\\testthat\\data"

base_path <- "./data"


test_that("libm01: lib_load() and lib_unload() functions works as expected.", {


  libname(dat, base_path, engine = "csv")


  # Should not get an error here
  suppressWarnings(lib_unload(dat))

  lib_load(dat)

  expect_equal(nrow(dat.demo_studya), 10)
  expect_equal(nrow(dat.demo_studyb), 2)

  lib_unload(dat)

  expect_equal("dat.demo_studya" %in% ls(), FALSE)
  expect_equal("dat.demo_studyb" %in% ls(), FALSE)

})


test_that("libm02: lib_size() works as expected.", {


  libname(dat, base_path, "csv")

  expect_equal(lib_size(dat) > 0, TRUE)
  expect_equal(lib_size(dat) < 900, TRUE)


})

test_that("libm03: lib_info() works as expected.", {


  libname(dat, base_path, "csv")

  info <- lib_info(dat)

  expect_equal(nrow(info) > 0, TRUE)
  expect_equal(info[1, "Size"] != "" ,  TRUE)


})



test_that("libm04: lib_path() works as expected.", {


  libname(dat, base_path, "csv")

  pth <- lib_path(dat)

  expect_equal(pth, base_path)


})


test_that("libm05: lib_sync() function works as expected.", {


  libname(dat, base_path, engine = "csv")

  ld <- is.loaded.lib("dat")

  expect_equal(ld, FALSE)

  lib_load(dat)

  ld <- is.loaded.lib("dat")

  expect_equal(ld, TRUE)

  acount <- nrow(dat.demo_studya)
  bcount <- nrow(dat.demo_studyb)

  tmp <- dat.demo_studya
  dat.demo_studya <- dat.demo_studyb
  dat.demo_studyb <- tmp

  dat <- lib_sync(dat)

  expect_equal(nrow(dat$demo_studya), bcount)
  expect_equal(nrow(dat$demo_studyb), acount)

  lib_unload(dat)

  ld <- is.loaded.lib("dat")

  expect_equal(ld, FALSE)

})




test_that("libm06: lib_sync() function can add a new item from workspace.", {


  libname(dat, base_path, engine = "csv")


  lib_load(dat)

  dat.demo_studyc <- mtcars

  lib_sync(dat)

  expect_equal(length(dat), 3)

})

test_that("libm07: lib_unload() function can add a new item from workspace.", {


  libname(dat, base_path, engine = "csv")


  lib_load(dat)

  dat.demo_studyc <- mtcars

  lib_unload(dat)

  expect_equal(length(dat), 3)

})


test_that("libm08: lib_add() function works as expected unloaded.", {

  alt_path <- tempdir()
  libname(dat, alt_path)

  lib_add(dat, mtcars, iris)

  inf <- lib_info(dat)

  expect_equal(length(dat), 2)
  expect_equal(nrow(inf), 2)

  lib_add(dat, mtcars, iris, name = c("fork", "bork"))

  expect_equal(length(dat), 4)

  lib_delete(dat)

})

test_that("libm09: lib_add() function works as expected loaded.", {

  alt_path <- tempdir()
  libname(dat, alt_path)

  lib_load(dat)

  lib_add(dat, mtcars, iris)

  inf <- lib_info(dat)

  expect_equal(length(dat), 2)
  expect_equal(nrow(inf), 2)

  lib_add(dat, mtcars, iris, name = c("fork", "bork"))

  expect_equal(length(dat), 4)

  lib_unload(dat)

  lib_delete(dat)

})


test_that("libm10: lib_remove() work as expected with multiple names.", {

  alt_path <- tempdir()
  libname(dat, alt_path)

  lib_add(dat, mtcars, iris)

  expect_equal(length(dat), 2)

  lib_remove(dat, c("mtcars", "iris"))

  expect_equal(length(dat), 0)

  lib_delete(dat)

})


test_that("libm11: lib_add(), lib_remove() functions work as expected unloaded.", {

  alt_path <- tempdir()
  libname(dat, alt_path)

  lib_add(dat, mtcars, iris)

  expect_equal(length(dat), 2)

  lib_remove(dat, "mtcars")

  expect_equal(length(dat), 1)

  lib_delete(dat)

})


test_that("libm12: lib_add(), lib_remove() functions work as expected loaded.", {

  alt_path <- tempdir()
  libname(dat, alt_path)

  lib_load(dat)

  lib_add(dat, mtcars, iris)

  expect_equal(length(dat), 2)

  lib_remove(dat, "mtcars")

  expect_equal(length(dat), 1)

  lib_remove(dat, "iris")

  expect_equal(length(dat), 0)

  lib_unload(dat)

  lib_delete(dat)
})



test_that("libm13: lib_write() function can add a new item and save as rds.", {

  alt_path <- tempdir()
  libname(dat, alt_path)

  lib_add(dat, mtcars)

  lib_write(dat)

  res <- file.exists(file.path(alt_path, "mtcars.rds"))

  expect_equal(res, TRUE)

  lib_remove(dat, "mtcars")

  lib_delete(dat)

})


test_that("libm14: lib_add() function can add a new item and save as csv", {

  alt_path <- tempdir()
  libname(dat, alt_path, engine = "csv")

  lib_add(dat, mtcars)

  res <- file.exists(file.path(alt_path, "mtcars.csv"))

  expect_equal(res, TRUE)

  lib_delete(dat)

})


test_that("libm15: lib_add() function can add a new item and save as xslx", {

  alt_path <- tempdir()
  libname(dat, alt_path, engine = "xlsx")

  lib_add(dat, mtcars)

  res <- file.exists(file.path(alt_path, "mtcars.xlsx"))

  expect_equal(res, TRUE)

  lib_delete(dat)

})


test_that("libm16: lib_add() function can add a new item and save as rds", {

  alt_path <- tempdir()
  libname(dat, alt_path, engine = "rds")

  lib_add(dat, mtcars)

  res <- file.exists(file.path(alt_path, "mtcars.rds"))

  expect_equal(res, TRUE)

  lib_delete(dat)

})


test_that("libm17: lib_add() function can add a new item and save as sas7bdat", {

  alt_path <- tempdir()
  libname(dat, alt_path, engine = "sas7bdat")

  lib_add(dat, mtcars)

  res <- file.exists(file.path(alt_path, "mtcars.sas7bdat"))

  #expect_equal(res, TRUE)
  expect_equal(res, FALSE) # FALSE for now

  lib_delete(dat)

})

test_that("libm18: lib_write() function can add a new item to sas7bdat libname from workspace.", {
  
  alt_path <- tempdir()
  libname(dat, alt_path, engine = "sas7bdat")
  
  
  lib_load(dat)
  
  dat.demo_studyc <- mtcars
  
  lib_write(dat)
  
  pth <- file.path(lib_path(dat), "demo_studyc.sas7bdat")
  
  res <- file.exists(pth)
  
  # expect_equal(res, TRUE)
  expect_equal(res, FALSE) # For now this is false.  Hope to make it true in the future.
  
  lib_delete(dat)
  
})


test_that("libm19: lib_write() function can add a new item from workspace.", {

  alt_path <- tempdir()
  libname(dat, alt_path, engine = "csv")


  lib_load(dat)

  dat.demo_studyc <- mtcars

  lib_write(dat)

  pth <- file.path(lib_path(dat), "demo_studyc.csv")

  res <- file.exists(pth)

  expect_equal(res, TRUE)

  lib_delete(dat)

})


test_that("libm20: lib_copy() works as expected.", {

  alt_path <- tempdir()

  libname(dat, base_path, "csv")

  lib_copy(dat, dat2, alt_path)

  expect_equal(file.exists(file.path(alt_path, "demo_studyb.csv")), TRUE)

  lib_delete(dat2)


})

test_that("libm21: read-only flag works as expected.", {


  libname(dat, base_path, "csv", read_only = TRUE)

  expect_error(lib_add(dat, mtcars))
  expect_error(lib_remove(dat, "demo_studya"))
  expect_error(lib_delete(dat))
  expect_error(lib_write(dat))
  expect_error(lib_replace(dat, mtcars, "demo_studya"))


})


test_that("libm22: lib_write non-changed csv data works as expected.", {

  alt_path <- tempdir()

  libname(dat, base_path, "csv")

  lib_copy(dat, dat2, alt_path)

  info1 <- lib_info(dat2)

  Sys.sleep(2)

  lib_replace(dat2, mtcars, name = "demo_studya")


  info2 <- lib_info(dat2)

  d1 <- subset(info1, Name == "demo_studya")
  d2 <- subset(info2, Name == "demo_studya")

  d3 <- subset(info1, Name == "demo_studyb")
  d4 <- subset(info2, Name == "demo_studyb")

  expect_equal(d1[1, 6] == d2[1, 6], FALSE)
  expect_equal(d3[1, 6] == d4[1, 6], TRUE)


  lib_delete(dat2)

})

test_that("libm23: lib_write non-changed rds data works as expected.", {

  alt_path <- tempdir()

  libname(dat, base_path, "rds")

  lib_copy(dat, dat2, alt_path)

  info1 <- lib_info(dat2)

  Sys.sleep(2)

  lib_replace(dat2, mtcars, name = "demo_studya")


  info2 <- lib_info(dat2)

  d1 <- subset(info1, Name == "demo_studya")
  d2 <- subset(info2, Name == "demo_studya")

  d3 <- subset(info1, Name == "demo_studyb")
  d4 <- subset(info2, Name == "demo_studyb")

  expect_equal(d1[1, 6] == d2[1, 6], FALSE)
  expect_equal(d3[1, 6] == d4[1, 6], TRUE)


  lib_delete(dat2)

})

# Copy won't work for sas7bdat
# test_that("lib_write non-changed sas7bdat data works as expected.", {
# 
#   alt_path <- tempdir()
# 
#   libname(dat, base_path, "sas7bdat")
# 
#   lib_copy(dat, dat2, alt_path)
# 
#   info1 <- lib_info(dat2)
# 
#   Sys.sleep(2)
# 
#   lib_replace(dat2, mtcars, name = "demo_studya")
# 
# 
#   info2 <- lib_info(dat2)
# 
# 
#   d1 <- subset(info1, Name == "demo_studya")
#   d2 <- subset(info2, Name == "demo_studya")
# 
#   d3 <- subset(info1, Name == "demo_studyb")
#   d4 <- subset(info2, Name == "demo_studyb")
# 
#   expect_equal(d1[1, 5] == d2[1, 5], FALSE)
#   expect_equal(d3[1, 5] == d4[1, 5], TRUE)
# 
#   lib_delete(dat2)
# 
# })

test_that("libm24: lib_write non-changed xlsx data works as expected.", {

  alt_path <- tempdir()

  libname(dat, base_path, "xlsx")

  lib_copy(dat, dat2, alt_path)

  info1 <- lib_info(dat2)

  Sys.sleep(2)

  lib_replace(dat2, mtcars, name = "demo_studya")

  lib_write(dat2)

  info2 <- lib_info(dat2)

  expect_equal(info1[2, 6] == info2[2, 6], TRUE)
  expect_equal(info1[1, 6] == info2[1, 6], FALSE)

  lib_delete(dat2)

})



test_that("libm25: force option works as expected.", {

  tmp <- tempdir()

  libname(dat, tmp)


  lib_add(dat, mtcars)

  res <- lib_info(dat)

  Sys.sleep(2)

  lib_write(dat, force = TRUE)

  res2 <- lib_info(dat)

  expect_equal(res[1, 6] == res2[1, 6],  FALSE)

  lib_delete(dat)

})


test_that("libm26: xpt engine works as expected.", {

  tmp <- tempdir()

  libname(dat, tmp, "xpt")


  lib_add(dat, mtcars)

  expect_equal(file.exists(file.path(tmp, "mtcars.xpt")), TRUE)

  libname(dat2, tmp, "xpt")

  expect_equal(nrow(dat2$mtcars),  32)

  lib_delete(dat)
  lib_delete(dat2)

})

test_that("libm27: Read existing xpt files.", {

  tmp <- tempdir()

  libname(dat, base_path, "xpt", filter = "ad*")


  expect_equal(length(dat), 2)

  expect_equal(nrow(dat$adae), 1191)
  expect_equal(nrow(dat$adsl), 254)


})



test_that("libm28: dbf engine works as expected.", {

  tmp <- tempdir()

  libname(dat, tmp, "dbf")


  lib_add(dat, mtcars)

  expect_equal(file.exists(file.path(tmp, "mtcars.dbf")), TRUE)

  libname(dat2, tmp, "dbf")

  expect_equal(nrow(dat2$mtcars),  32)

  lib_delete(dat)
  lib_delete(dat2)

})

test_that("libm29: dbf engine works as expected with tibble.", {

  tmp <- tempdir()

  libname(dat, tmp, "dbf")


  lib_add(dat, as_tibble(mtcars), name = "mtcars")

  expect_equal(file.exists(file.path(tmp, "mtcars.dbf")), TRUE)

  libname(dat2, tmp, "dbf")

  expect_equal(nrow(dat2$mtcars),  32)

  lib_delete(dat)
  lib_delete(dat2)

})

test_that("libm30: lib_load() function works as expected with filter", {


    libname(dat, file.path( base_path, "SDTM"),
            engine = "sas7bdat")

    lib_load(dat, c("ae", "dm", "lb", "vs"))

    d <- ls()

    expect_equal(all(c("dat.ae", "dat.dm", "dat.lb", "dat.vs") %in% d), TRUE)
    expect_equal(any(c("dat.da", "dat.ds", "dat.ex", "dat.pe") %in% d), FALSE)

    lib_unload(dat)


    lib_load(dat, filter = c("*e"))

    d <- ls()

    expect_equal(all(c("dat.ae", "dat.ie", "dat.pe") %in% d), TRUE)
    expect_equal(any(c("dat.da", "dat.ds", "dat.ex", "dat.lb") %in% d), FALSE)

    lib_unload(dat)


    lib_load(dat, filter = c("d*", "ex", "qs"))

    d <- ls()

    expect_equal(all(c("dat.da", "dat.dm", "dat.ds", "dat.ds_ihor",
                       "dat.ex", "dat.qs") %in% d), TRUE)
    expect_equal(any(c("dat.ae", "dat.lb", "dat.pe", "dat.ie") %in% d), FALSE)

    lib_unload(dat)

})


test_that("libm31: lib_write() changed csv data works as expected.", {


  alt_path <- tempdir()

  libname(dat, base_path, "csv")

  lib_copy(dat, dat2, alt_path)


  l1 <- lib_info(dat2)
  
  l1 
  
  expect_equal(nrow(l1), 2)
  
  d1 <- dat2$demo_studyb

  d1$visit[1] <- 1

  dat2$demo_studyb <- d1

  dat2$demo_studyc <- mtcars
  
  Sys.sleep(2)

  lib_write(dat2)

  l2 <- lib_info(dat2)
  
  l2

  expect_equal(nrow(l2), 3)
  expect_equal(l1[[1, "LastModified"]] == l2[[1, "LastModified"]], TRUE)
  expect_equal(l1[[2, "LastModified"]] == l2[[2, "LastModified"]], FALSE)

  lib_delete(dat2)

})

context("Datastep Attributes Tests")

base_path <- "c:\\packages\\libr\\tests\\testthat\\data"

base_path <- "./data"

DEV <- FALSE


test_that("dsattr() function works", {


  dsa <- dsattr(class = "character", label = "My label", description = "Desc",
                format = "%s", width = 8, justify = "left", fork = "hi",
                bork = "bye")

  expect_equal(dsa$class, "character")
  expect_equal(dsa$label, "My label")
  expect_equal(dsa$description, "Desc")
  expect_equal(dsa$format, "%s")
  expect_equal(dsa$width, 8)
  expect_equal(dsa$justify, "left")
  expect_equal(dsa$fork, "hi")
  expect_equal(dsa$bork, "bye")

})




test_that("dsattr function works with datastep and new variable.", {

  dsa <- dsattr(class = "character", label = "My label", description = "Desc",
                format = "%s", width = 8, justify = "left", fork = "hi",
                bork = "bye")


  dat <- mtcars[1:10, ]

  attr(dat$mpg, "label") <- "Miles Per Gallon"

  expect_equal(attr(dat$mpg, "label"), "Miles Per Gallon")


  d1 <- datastep(dat, attrib = list(fork = dsa), {

    fork <- "Hello"

  })

  attributes(d1$mpg)
  attributes(d1$fork)


  expect_equal("fork" %in% names(d1), TRUE)
  expect_equal(class(d1[["fork"]]), "character")
  expect_equal(attr(d1[["fork"]], "label"), "My label")
  expect_equal(attr(d1[["fork"]], "description"), "Desc")
  expect_equal(attr(d1[["fork"]], "format"), "%s")
  expect_equal(attr(d1[["fork"]], "width"), 8)
  expect_equal(attr(d1[["fork"]], "justify"), "left")
  expect_equal(attr(d1[["fork"]], "fork"), "hi")
  expect_equal(attr(d1[["fork"]], "bork"), "bye")
  expect_equal(attr(d1[["mpg"]], "label"), "Miles Per Gallon")
})




test_that("dsattr function works with datastep and two new variables.", {

  dsa1 <- dsattr(class = "character", label = "My label1")
  dsa2 <- dsattr(class = "character", label = "My label2", format = "%1.1f")


  dat <- mtcars[1:10, ]

  attr(dat$mpg, "label") <- "Miles Per Gallon"

  expect_equal(attr(dat$mpg, "label"), "Miles Per Gallon")


  d1 <- datastep(dat, attrib = list(fork = dsa1, bork = dsa2), {

    fork <- "Hello"
    bork <- "Goodbye"

  })

  attributes(d1$fork)
  attributes(d1$bork)

  d1


  expect_equal("fork" %in% names(d1), TRUE)
  expect_equal("bork" %in% names(d1), TRUE)
  expect_equal(attr(d1[["fork"]], "label"), "My label1")
  expect_equal(attr(d1[["bork"]], "label"), "My label2")
  expect_equal(attr(d1[["mpg"]], "label"), "Miles Per Gallon")
  expect_equal(attr(d1[["bork"]], "format"), "%1.1f")
})


test_that("dsattr function works with datastep and a tibble.", {

  library(tibble)

  dsa1 <- dsattr(class = "character", label = "My label1")
  dsa2 <- dsattr(class = "character", label = "My label2")


  dat <- as_tibble(mtcars[1:10, ])

  attr(dat$mpg, "label") <- "Miles Per Gallon"

  expect_equal(attr(dat$mpg, "label"), "Miles Per Gallon")


  d1 <- datastep(dat, attrib = list(fork = dsa1, bork = dsa2), {

    fork <- "Hello"
    bork <- "Goodbye"

  })

  attributes(d1$fork)
  attributes(d1$bork)

  d1


  expect_equal("fork" %in% names(d1), TRUE)
  expect_equal("bork" %in% names(d1), TRUE)
  expect_equal(attr(d1[["fork"]], "label"), "My label1")
  expect_equal(attr(d1[["bork"]], "label"), "My label2")
  expect_equal(attr(d1[["mpg"]], "label"), "Miles Per Gallon")
})


test_that("attrib parameter works with datastep and no dsattr.", {



  dat <- mtcars[1:10, ]


  d1 <- datastep(dat, attrib = list(fork = "", bork = 0), {


  })

  attributes(d1$fork)
  attributes(d1$bork)

  d1


  expect_equal("fork" %in% names(d1), TRUE)
  expect_equal("bork" %in% names(d1), TRUE)
  expect_equal(d1[["fork"]][1], "")
  expect_equal(d1[["bork"]][1], 0)



  d2 <- datastep(dat, attrib = list(fork = "hello", bork = 23), {


  })


  d2


  expect_equal("fork" %in% names(d2), TRUE)
  expect_equal("bork" %in% names(d2), TRUE)
  expect_equal(d2[["fork"]][1], "hello")
  expect_equal(d2[["bork"]][1], 23)

})


test_that("dsattr function works with datastep and calculated variable.", {
  
  dsa <- dsattr(class = "character", label = "My label", description = "Desc",
                format = "%s", width = 8, justify = "left", fork = "hi",
                bork = "bye")
  
  
  dat <- mtcars[1:10, ]
  
  attr(dat$mpg, "label") <- "Miles Per Gallon"
  
  expect_equal(attr(dat$mpg, "label"), "Miles Per Gallon")
  
  
  d1 <- datastep(dat, attrib = list(fork = dsa), 
                 calculate = {fork = 1}, {
    
  })
  
  attributes(d1$mpg)
  attributes(d1$fork)
  
  
  expect_equal("fork" %in% names(d1), TRUE)
  expect_equal(class(d1[["fork"]]), "numeric")
  expect_equal(attr(d1[["fork"]], "label"), "My label")
  expect_equal(attr(d1[["fork"]], "description"), "Desc")
  expect_equal(attr(d1[["fork"]], "format"), "%s")
  expect_equal(attr(d1[["fork"]], "width"), 8)
  expect_equal(attr(d1[["fork"]], "justify"), "left")
  expect_equal(attr(d1[["fork"]], "fork"), "hi")
  expect_equal(attr(d1[["fork"]], "bork"), "bye")
  expect_equal(attr(d1[["mpg"]], "label"), "Miles Per Gallon")
})

context("Utilities Tests")

base_path <- "c:\\packages\\libr\\tests\\testthat\\data"

base_path <- "./data"

DEV <- FALSE

test_that("utils01: print() functions works as expected.", {
  
  if (DEV) {

  libname(dat, base_path, engine = "csv")

  
  dat
  
  expect_equal(is.lib(dat), TRUE)
  
  res <- capture.output(print(dat))
  
  expect_equal(length(res) > 0, TRUE)
  
  
  res2 <- capture.output(print(dat, verbose = TRUE))
  
  expect_equal(length(res2) > 0, TRUE)
  
  } else 
    expect_equal(TRUE, TRUE)
  
})


test_that("utils02: dofilter function works as expected for paths", {
  
  
  v1 <- c("/temp/fork.csv", "/temp/four.csv", "/temp/spork.csv")
  
  expect_equal(dofilter("fo*", v1, "csv"), c("/temp/fork.csv", "/temp/four.csv"))
  
  expect_equal(dofilter("fork", v1, "csv"), c("/temp/fork.csv"))
  
  expect_equal(is.null(dofilter("or*", v1, "csv")), TRUE)
  
  expect_equal(dofilter("*or*", v1, "csv"), c("/temp/fork.csv","/temp/spork.csv"))
  
  expect_equal(dofilter(c("fo*", "sp*"), v1, "csv"), c("/temp/fork.csv", 
                                                       "/temp/four.csv", 
                                                       "/temp/spork.csv"))
  
  expect_equal(dofilter(c("Fo*", "SP*"), v1, "csv"), c("/temp/fork.csv",
                                                       "/temp/four.csv",
                                                       "/temp/spork.csv"))
  
})


test_that("utils03: dofilter function works as expected for names", {
  
  
  v2 <- c("fork", "four", "spork")
  
  expect_equal(dofilter("fo*", v2),  c("fork", "four"))
  
  expect_equal(dofilter("fork", v2),  c("fork"))
  
  expect_equal(is.null(dofilter("or*", v2)),  TRUE)
  
  expect_equal(dofilter("*or*", v2),  c("fork", "spork"))
  
  expect_equal(dofilter(c("fo*", "sp*"), v2),  c("fork", "four", "spork"))
  
  expect_equal(dofilter(c("fork", "spork"), v2),  c("fork", "spork"))
  
  expect_equal(dofilter(c("FORK", "Sp*"), v2),  c("fork", "spork"))
  
})

test_that("utils04: copy_attributes function works as expected.", {
  
  d1 <- mtcars
  d2 <- mtcars
  
  attr(d1$mpg, "label") <- "Here1"
  attr(d1$disp, "label") <- "Here2"

  d3 <- copy_attributes(d1, d2)

  expect_equal(attr(d3$mpg, "label"), "Here1")
  expect_equal(attr(d3$disp, "label"), "Here2")
  
})


test_that("utils05: getExtension() works with two dots", {
  
  flnm <- "table_hemo.1.csv"
  
  res <- getExtension(flnm)
  
  expect_equal(length(res), 1)
  expect_equal(res, "csv")
  
  
})


test_that("utils06: getsignatures() works as expected.", {
  
  s1 <- serialize(iris, NULL)
  
  
  s1[1]

  
  m1 <- getBitSignature(s1)  
  m2 <- getsigs(s1)
  
  m1
  m2
  
  expect_equal(m1 == m2, TRUE)
  
})

test_that("utils07: captureSignatures() works as expected.", {
  
  
  m1 <- mtcars
  m2 <- mtcars
  m3 <- mtcars
  
  m2[1, "carb"] <- 3
  attr(m3, "fork") <- 1
  
  s1 <- captureSignatures(m1)
  s2 <- captureSignatures(m2)
  s3 <- captureSignatures(m3)
  
  expect_equal(s1$Length == s2$Length, TRUE)
  expect_equal(s1$Hex == s2$Hex, FALSE)
  expect_equal(s1$Length == s3$Length, TRUE)
  expect_equal(s1$Hex == s3$Hex, TRUE)
  
})


# 
# test_that("libname() var_name parameter works as expected.", {
#   
#   
#   
#   expect_equal(standard_eval(), FALSE)
#   
#   options("libr.standard_eval" = TRUE)
#   
#   expect_equal(standard_eval(), TRUE)
#   
#   options("libr.standard_eval" = FALSE)
#   
#   expect_equal(standard_eval(), FALSE)
#   
#   
#   
#   
# })

context("Datastep Array Tests")

base_path <- "c:\\packages\\libr\\tests\\testthat\\data"

base_path <- "./data"

DEV <- FALSE


test_that("dsarray() function works", {


  dsa <- dsarray("one", "two", "three", "four")

  expect_equal(length(dsa), 4)
  expect_equal(length(names(dsa)), 4)
  expect_equal("dsarray" %in% class(dsa), TRUE)
  expect_equal(as.character(dsa), c("one", "two", "three", "four"))
  expect_equal(names(dsa), c("one", "two", "three", "four"))

})




test_that("dsarray function works with character index.", {



  d1 <- datastep(mtcars, arrays = list(dsa = dsarray("vs", "am", "gear")), {

    temp <- dsa["am"]

  })

  expect_equal("temp" %in% names(d1), TRUE)
  expect_equal(d1[["temp"]], mtcars[["am"]])

})




test_that("dsarray function works with numeric index.", {



  d1 <- datastep(mtcars, arrays = list(dsa = dsarray("vs", "am", "gear")), {

    temp <- dsa[2]

  })

  expect_equal("temp" %in% names(d1), TRUE)
  expect_equal(d1[["temp"]], mtcars[["am"]])

})


test_that("dsarray function works with factors.", {

  dat <- mtcars
  dat$cat <- factor("A")

  d1 <- datastep(dat, arrays = list(dsa = dsarray("vs", "am", "gear", "cat")), {

    temp <- dsa[4]
    temp2 <- dsa["cat"]

  })

  expect_equal("temp" %in% names(d1), TRUE)
  expect_equal(d1[["temp"]], as.character(dat[["cat"]]))

  expect_equal("temp2" %in% names(d1), TRUE)
  expect_equal(d1[["temp2"]], as.character(dat[["cat"]]))

})


test_that("dsarray function works with no index.", {



  d1 <- datastep(mtcars, {

    temp <- sum(dsa[])
    temp2 <- mean(dsa[])

  }, arrays = list(dsa = dsarray("vs", "am", "gear")))

  expect_equal("temp" %in% names(d1), TRUE)
  expect_equal("temp2" %in% names(d1), TRUE)
  expect_equal(d1[["temp"]], mtcars[["vs"]] + mtcars[["am"]] + mtcars[["gear"]])

})


test_that("dsarray dynamic assignment works as expected.", {

  if (DEV) {

    d1 <- datastep(mtcars, {
  
      temp <- !dsa[1]
  
      for (nm in dsa) {
  
       assign(nm, dsa[nm] + 2)
      }
  
  
    }, arrays = list(dsa = dsarray("vs", "am", "gear")))
  
    d1
  
    expect_equal("temp" %in% names(d1), TRUE)
    expect_equal(d1[["vs"]], mtcars[["vs"]] + 2)
    expect_equal(d1[["am"]], mtcars[["am"]] + 2)
    expect_equal(d1[["gear"]], mtcars[["gear"]] + 2)
  
  } else 
    expect_equal(TRUE, TRUE)

})


test_that("length.dsarray works as expected.", {

  dsa <- dsarray("vs", "am", "gear")

  expect_equal(length(dsa), 3)



})

test_that("names.dsarray works as expected.", {

  dsa <- dsarray("vs", "am", "gear")

  as.character(dsa)

  expect_equal(names(dsa), c("vs", "am", "gear"))



})

test_that("dsarray dynamic assignment to new variables works as expected.", {


  if (DEV) {

    d1 <- datastep(mtcars, arrays = list(dsa = dsarray("vs", "am", "gear"),
                                         dsa1 = c("vs1", "am1", "gear1")),
                   steps = {
  
  
      for (i in seq_along(dsa)) {
  
        assign(dsa1[i], dsa[i] * 2)
      }
  
  
    })
  
    d1
  
    expect_equal("vs1" %in% names(d1), TRUE)
    expect_equal(d1[["vs1"]], mtcars[["vs"]] * 2)
    expect_equal(d1[["am1"]], mtcars[["am"]] * 2)
    expect_equal(d1[["gear1"]], mtcars[["gear"]] * 2)
    
  } else {
    expect_equal(TRUE, TRUE) 
  }
})



test_that("for loop and data type check works as expected.", {

  if (DEV) {
    d1 <- datastep(mtcars,
                   arrays = list(dsa = dsarray("vs", "am", "gear", "fork")),
                   calculate = {
  
      fork <- "my value"
  
  
    }, drop = "nm",
      steps =
  
      {
      rownum <- n.
  
      for (nm in dsa) {
        if (class(dsa[nm]) == "character")
            assign(nm, paste(dsa[nm], n.))
        else
            assign(nm, dsa[nm] + n.)
      }
  
  
    })
  
    d1
  
    expect_equal("fork" %in% names(d1), TRUE)
    expect_equal("rownum" %in% names(d1), TRUE)

  } else {
    expect_equal(TRUE, TRUE) 
  }
})


test_that("System test of datastep array.", {

  dfin <- read.table(header = TRUE, text = '
   C1 C2 C3 C4 C5 C6 C7
   12 R11 D21 201901 09 D89 Real
   21 R23 D77 201901 21 D77 Fetched
   33 R43 D87 201901 31 D87 Real
   33 R43 D87 201901 31 D87 Fetched
   57 R12 D87 201901 12 D87 Fetched')


  dfout <- datastep(dfin,
                    arrays = list(dsa = dsarray(names(dfin[1:6]))),
                    drop = c("nm"),
                    {


                      # After the first row
                      if (n. > 1) {

                        # Loop through column array
                        for (nm in dsa) {

                          # If any of the first 6 columns don't match
                          # or C7 is equal to Real, keep the row
                          #print(paste0("DSA", n., ":", dsa[nm]))
                          #print(paste0("data", n., ":", data[[n. - 1, nm]]))
                          if (as.character(data[[n., nm]]) != as.character(data[[n. - 1, nm]]) ||
                              C7 == "Real") {
                            delete <- FALSE
                            break
                          } else {

                            delete <- TRUE

                          }

                        }

                      } else {

                        # Keep first row by default
                        delete <- FALSE
                      }

                    })

  # See results of datastep
  dfout
  #   C1  C2  C3     C4 C5  C6      C7 delete
  # 1 12 R11 D21 201901  9 D89    Real  FALSE
  # 2 21 R23 D77 201901 21 D77 Fetched  FALSE
  # 3 33 R43 D87 201901 31 D87    Real  FALSE
  # 4 33 R43 D87 201901 31 D87 Fetched   TRUE
  # 5 57 R12 D87 201901 12 D87 Fetched  FALSE

  #print(dfout)

  expect_equal(nrow(dfout), 5)

  # Filter out rows flagged for deletion
  res <- dfout[dfout$delete == FALSE, names(dfout)[1:7]]
  #print(res)
  res
  #   C1  C2  C3     C4 C5  C6      C7
  # 1 12 R11 D21 201901  9 D89    Real
  # 2 21 R23 D77 201901 21 D77 Fetched
  # 3 33 R43 D87 201901 31 D87    Real
  # 5 57 R12 D87 201901 12 D87 Fetched

  expect_equal(nrow(res), 4)
})


test_that("System test of datastep array.", {

  df <- read.table(header = TRUE, text = '
      C1    C2
       3    A1
       2    A2
       1    A3
  ')


  dt <- datastep(df,
                 arrays = list(arr1 = dsarray("C1", "C2")),
                 {

                    D1 <- arr1["C1"]
                    D2 <- arr1["C2"]

                 })
  #print(dt)
  expect_equal(dt$D1, c(3, 2, 1))
  #print(dt$D2)
  expect_equal(dt$D2, c("A1", "A2", "A3"))

})

context("Datastep Tests")

base_path <- "c:\\packages\\libr\\tests\\testthat\\data"

base_path <- "./data"


options("logr.output" = FALSE)

dev <- FALSE

test_that("ds1: datastep() function works as expected with mtcars.", {

  
  d1 <- datastep(mtcars, {

    if (mpg >= 20)
      mpgcat <- "High"
    else
      mpgcat <- "Low"

  })

  d1

  expect_equal("mpgcat" %in% names(d1), TRUE)

})



test_that("ds2: datastep() function works as expected with demo_studya.", {


  libname(dat, base_path, "csv")

  lib_load(dat)

  d1 <- datastep(dat.demo_studya, {

    if (sex == "M")
      sexc <- "Male"
    else if(sex == "F")
      sexc <- "Female"
    else
      sexc <- "Other"

  })

  d1

  expect_equal("sexc" %in% names(d1), TRUE)

})


test_that("ds3: datastep() keep parameter works as expected.", {

  libname(dat, base_path, "csv")

  lib_load(dat)

  d1 <- datastep(dat.demo_studya, keep = c("usubjid", "sexc", "race"), {

    usubjid <- paste0(study, "-", inv, "-", patient)
    if (sex == "M")
      sexc <- "Male"
    else if(sex == "F")
      sexc <- "Female"
    else
      sexc <- "Other"

  })

  d1

  expect_equal(names(d1), c("usubjid", "sexc", "race"))

})

test_that("ds4: datastep() drop parameter works as expected.", {

  libname(dat, base_path, "rds")

  lib_load(dat)

  d1 <- datastep(dat.demo_studya, drop = c("visit", "screendate", "sex"), {

    usubjid <- paste0(study, "-", inv, "-", patient)
    if (sex == "M")
      sexc <- "Male"
    else if(sex == "F")
      sexc <- "Female"
    else
      sexc <- "Other"

  })

  d1

  expect_equal(names(d1), c("study", "inv", "patient", "race",
                            "dob", "treatment", "usubjid", "sexc"))

})


test_that("ds5: datastep() by parameter first and last works as expected.", {

  libname(dat, base_path, "rds")

  lib_load(dat)


  d1 <- datastep(dat.demo_studya, by = c("treatment"), {

    f1 <- first.
    l1 <- last.

  })

  d1

  expect_equal(sum(d1$f1), 2)
  expect_equal(sum(d1$l1), 2)

})


test_that("ds6: datastep() summary functions works as expected.", {

  libname(dat, base_path, "rds")

  lib_load(dat)


  d1 <- datastep(dat.demo_studya, {

    pmean <- mean(data$patient)
    if (patient > pmean)
      pind <- TRUE
    else
      pind <- FALSE

    rownum <- n.
  })

  d1

  expect_equal(sum(d1$pind), 5)

})

test_that("ds7: datastep() calculate parameter works as expected.", {

  libname(dat, base_path, "rds")

  lib_load(dat)


  d1 <- datastep(dat.demo_studya,
    calculate = {
      pmean <- mean(patient)
    },{

    if (patient > pmean)
      pind <- TRUE
    else
      pind <- FALSE

    rownum <- n.
  })

  d1

  expect_equal(sum(d1$pind), 5)

})

test_that("ds8: datastep() auto-group-by works as expected.", {

  if (TRUE) {
    libname(dat, base_path, "rds")

    lib_load(dat)


    d1 <- dat.demo_studya %>% group_by(treatment) %>%
      datastep({
        p1 <- first.
        p2 <- last.
        rownum <- n.
      })

    d1

    expect_equal(sum(d1$p1), 2)
    expect_equal(sum(d1$p2), 2)
    expect_equal(sum(d1$rownum), 55)

    lib_unload(dat)

  } else
    expect_equal(TRUE, TRUE)
})

test_that("ds9: datastep() by parameter sort check works as expected.", {

  libname(dat, base_path, "rds")

  lib_load(dat)

  d1 <- datastep(dat.demo_studya, by = c("treatment"), {

    f1 <- first.
    l1 <- last.

  })

  expect_equal(sum(d1$f1), 2)
  expect_equal(sum(d1$l1), 2)

  d2 <- dat.demo_studya[order(dat.demo_studya$dob), ]

  expect_error(datastep(d2, by = c("treatment"), {

    f1 <- first.
    l1 <- last.

  }))

  d3 <- datastep(d2, by = c("treatment"), sort_check = FALSE, {

    f1 <- first.
    l1 <- last.

  })

  expect_equal(sum(d3$f1), 5)
  expect_equal(sum(d3$l1), 5)

})


test_that("ds10: datastep() retain parameter works as expected.", {

  libname(dat, base_path, "rds")

  lib_load(dat)

  d1 <- datastep(dat.demo_studya, retain = list("fork" = 0, bork = ""), {

    fork <- fork + 1

    if (first.)
      bork <- "begin"
    else if (last.)
      bork <- "end"
    else
      bork <- paste("middle", n.)

  })

  d1

  expect_equal(d1$fork[10], 10)
  expect_equal(d1$bork[1], "begin")
  expect_equal(d1$bork[2], "middle 2")
  expect_equal(d1$bork[10], "end")
})

test_that("ds11: datastep() retain class check works as expected", {


  expect_error(datastep(mtcars, retain = c(fork = 0), {fork <- fork + 1}))

})

test_that("ds12: datastep() array class check works as expected", {


  expect_error(datastep(mtcars, array = c(fork = 0), {fork <- fork + 1}))

})


test_that("ds13: datastep() attrib class check works as expected", {


  expect_error(datastep(mtcars, attrib = c(fork = 0), {fork <- fork + 1}))

})



test_that("ds14: Rename works as expected", {

  df <- datastep(mtcars[1:10, ],
    drop = c("disp", "hp", "drat", "qsec",
    "vs", "am", "gear", "carb"),
    retain = list(cumwt = 0 ),
    rename = c(mpg = "MPG", cyl = "Cylinders", wt = "Wgt",
    cumwt = "Cumulative Wgt"),
  {
    cumwt <- cumwt + wt
  })

  df

  expect_equal("MPG" %in% names(df), TRUE)
  expect_equal("Cylinders" %in% names(df), TRUE)
  expect_equal("Wgt" %in% names(df), TRUE)
  expect_equal("Cumulative Wgt" %in% names(df), TRUE)

})




test_that("ds15: datastep() attributes on data are maintained.", {

  library(dplyr)
  library(common)


  libname(dat, file.path(base_path, "SDTM"), "sas7bdat")

  attributes(dat$dm$USUBJID)

  prep <- dat$dm %>%
    left_join(dat$vs, by = c("USUBJID" = "USUBJID")) %>%
    select(USUBJID, VSTESTCD, VISIT, VISITNUM, VSSTRESN, ARM, VSBLFL) %>%
    filter(VSTESTCD %in% c("PULSE", "RESP", "TEMP", "DIABP", "SYSBP"),
           !(VISIT == "SCREENING" & VSBLFL != "Y")) %>%
    arrange(USUBJID, VSTESTCD, VISITNUM) %>%
    group_by(USUBJID, VSTESTCD) %>%

    datastep(retain = list(BSTRESN = 0), {

      # Combine treatment groups
      # And distingish baseline time points
      if (ARM == "ARM A") {

        if (VSBLFL %eq% "Y") {
          GRP <- "A_BASE"
        } else {
          GRP <- "A_TRT"
        }

      } else {

        if (VSBLFL %eq% "Y") {
          GRP <- "O_BASE"
        } else {
          GRP <- "O_TRT"
        }

      }

      # Populate baseline value
      if (first.)
        BSTRESN = VSSTRESN

    })


  expect_equal(attr(prep$USUBJID, "label"), "Unique Subject Identifier")


})

test_that("ds16: datastep retains class attributes.", {


  s1 <-  1:3
  dt1 <- c(Sys.Date(), Sys.Date() - 1, Sys.Date() - 2)
  df1 <- data.frame(s1, dt1, stringsAsFactors = FALSE)

  df2 <- datastep(df1, rename = c(dt1 = "dt2"), {
    csum <- 1
  })

  df2

  expect_equal(class(df2$s1), "integer")
  expect_equal(class(df2$dt2), "Date")
  expect_equal(class(df2$csum), "numeric")

})

test_that("ds17: datastep works on single column data frame.", {

  df <- data.frame(a = 1:10, stringsAsFactors = FALSE)


  df2 <- datastep(df, {

    if (a > 5)
      status <- "High"
    else
      status <- "Low"

  })

  df2

  expect_equal(ncol(df2), 2)
  expect_equal(nrow(df2), 10)
  expect_equal(class(df2), "data.frame")


})


test_that("ds18: datastep works on single column tibble.", {

  df <- tibble(a = 1:10)


  df2 <- datastep(df, {

    if (a > 5)
      status <- "High"
    else
      status <- "Low"

  })

  df2

  expect_equal(ncol(df2), 2)
  expect_equal(nrow(df2), 10)
  expect_equal(class(df2), c("tbl_df", "tbl", "data.frame"))


})


test_that("ds19: datastep() attributes on data are maintained on base dataframe.", {


  dat <- mtcars

  attr(dat$mpg, "label") <- "Miles Per Gallon"


  dat2 <- datastep(dat, {
    fork <- "Hello"
  })

  dat2

  expect_equal(attr(dat2$mpg, "label"), "Miles Per Gallon")

})



test_that("ds20: datastep works on tibble.", {



    library(tibble)

    l <- 1000

    df <- tibble(C1 = seq_len(l), C2 = runif(l),
                 C3 = runif(l), C4 = runif(l))


    res <- datastep(df, attrib = list(C5 = 0, C6 = 0),
                    {
                      C5 <- C2 + C3 + C4
                      C6 <- max(C2, C3, C4)

                    })

    res

    expect_equal("C5" %in% names(res), TRUE)
    expect_equal("C6" %in% names(res), TRUE)
    expect_equal(nrow(res), 1000)


})



test_that("ds21: datastep works on data.table", {



  library(data.table)

  l <- 1000

  df <- data.table(C1 = seq_len(l), C2 = runif(l),
               C3 = runif(l), C4 = runif(l))


  res <- datastep(df, attrib = list(C5 = 0, C6 = 0),
                  {
                    C5 <- C2 + C3 + C4
                    C6 <- max(C2, C3, C4)

                  })

  res

  expect_equal("C5" %in% names(res), TRUE)
  expect_equal("C6" %in% names(res), TRUE)
  expect_equal(nrow(res), 1000)


})



test_that("ds22: datastep() works on a dataframe with a factor.", {


  dat <- iris


  dat2 <- datastep(dat, {
    fork <- Petal.Length + Petal.Width
  })

  dat2

  expect_equal("fork" %in% names(dat2), TRUE)
  expect_equal(class(dat2$Species), "factor")

})

test_that("ds23: assign_attributes() works as expected.", {


  dat <- mtcars

  lst <- list(mpg = "hello", cyl = "goodbye")

  dat2 <- assign_attributes(dat, lst, "label")


  expect_equal(attr(dat2$mpg, "label"), "hello")
  expect_equal(attr(dat2$cyl, "label"), "goodbye")
})

test_that("ds24: label parameter on datastep works as expected.", {


  dat <- mtcars

  lst <- list(mpg = "hello", cyl = "goodbye")

  dat2 <- datastep(dat, label = lst, {})




  expect_equal(attr(dat2$mpg, "label"), "hello")
  expect_equal(attr(dat2$cyl, "label"), "goodbye")
})


test_that("ds25: format parameter on datastep works as expected.", {


  dat <- mtcars

  lst <- list(mpg = "%1.1f", cyl = "%1.2f")

  dat2 <- datastep(dat, format = lst, {})


  expect_equal(attr(dat2$mpg, "format"), "%1.1f")
  expect_equal(attr(dat2$cyl, "format"), "%1.2f")
})

test_that("ds26: Attributes on datastep input is retained inside datastep.", {

  library(common)

  dat <- mtcars

  labels(dat) <- list(mpg = "here", cyl = "there")

  attr(dat$mpg, "label")

  dat2 <- datastep(dat, format = list(cyl = "%1.1f"), {

    mpgf <- attr(mpg, "label")
    mpgf2 <- "Hello"
    cylf <- attr(cyl, "format")
  })

  dat2

  expect_equal("mpgf" %in% names(dat2), TRUE)
  expect_equal(dat2[1, "mpgf"], "here")
  expect_equal("cylf" %in% names(dat2), TRUE)
  expect_equal(dat2[1, "cylf"], "%1.1f")

})

test_that("ds27: date variables are retained as dates.", {


  ind <- mtcars
  ind$mydate <- Sys.Date()

  df <- datastep(ind, {

    if (mpg >= 20)
      mpgcat <- "High"
    else
      mpgcat <- "Low"

    recdt <- as.Date("1974-06-10")

    if (cyl == 8)
      is8cyl <- TRUE
    else
      is8cyl <- FALSE

  })


  df


  a1 <- attributes(df$recdt)
  a2 <- attributes(df$mydate)


  expect_equal(a1$class, "Date")
  expect_equal(a2$class, "Date")

})


test_that("ds28: where clause works.", {

  df <- datastep(mtcars,
                 where = expression(cyl == 8),
                  {

                   if (mpg >= 20)
                     mpgcat <- "High"
                   else
                     mpgcat <- "Low"

                   recdt <- as.Date("1974-06-10")

                   if (cyl == 8)
                     is8cyl <- TRUE
                   else
                     is8cyl <- FALSE

                 })

  df

  expect_equal(mean(df$cyl), 8)

})


test_that("ds29: attributes are retained with keep statement.", {


  ind <- mtcars
  ind$mydate <- Sys.Date()

  df <- datastep(ind,
                 format = list(cyl = "%.1f",
                               mydate = "%b %m %Y",
                               recdt = "%b %m %y"),
                 keep = c("mpg", "cyl", "recdt", "mydate"), {


    recdt <- as.Date("1974-06-10")


  })

  df

  a1 <- attributes(df$recdt)
  a2 <- attributes(df$mydate)
  a3 <- attributes(df$cyl)


  expect_equal(a1$class, "Date")
  expect_equal(a2$class, "Date")
  expect_equal(a1$format,  "%b %m %y")
  expect_equal(a2$format, "%b %m %Y")
  expect_equal(a3$format, "%.1f")

})

test_that("ds30: datastep() keep parameter with one variable works.", {

  libname(dat, base_path, "csv")

  lib_load(dat)

  d1 <- datastep(dat.demo_studya, keep = c("study"), {})

  d1

  expect_equal("data.frame" %in% class(d1), TRUE)
  expect_equal(names(d1), c("study"))


})

# test_that("output variable  on datastep works as expected.", {
#
#
#   dat <- datastep(mtcars, {if (cyl == 8) output = TRUE})
#
#
#   expect_equal("output" %in% names(dat), FALSE)
#   expect_equal(nrow(dat), 14)
# })


test_that("ds31: Single value NSE works on datastep().", {


  d1 <- datastep(mtcars,
                 drop = am,
                 keep = v(mpg, cyl, disp, cylgrp),
                 by = cyl,
                 sort_check = FALSE, {

    if (first.)
      cylgrp <- "begin"
    else
      cylgrp <- "-"

  })

  d1

  expect_equal(ncol(d1), 4)


  d2 <- datastep(d1, keep = cylgrp, {})

  expect_equal(ncol(d2), 1)

})

test_that("ds32: Delete function works on datastep().", {


  d1 <- datastep(mtcars,
                 keep = v(mpg, cyl, disp, cylgrp),
                 by = cyl,
                 sort_check = FALSE, {

                   if (first.)
                     cylgrp <- "begin"
                   else
                     delete()

                 })

  d1

  expect_equal(ncol(d1), 4)
  expect_equal(nrow(d1), 16)

  # Should get no errors
  d2 <- datastep(mtcars,
                 {delete()})

  d2

  expect_equal(nrow(d2), 0)
  expect_equal(ncol(d2), 11)

})


test_that("ds33: Output function works as expected.", {


  d1 <- datastep(mtcars,
                 {

                   if (cyl == 4)
                     output()

                 })

  d1

  expect_equal(nrow(d1), 11)
  expect_equal(ncol(d1), 11)

})

test_that("ds34: has_output() function works.", {

  str1 <- "if (cyl == 4) output()"

  res1 <- has_output(str1)

  res1

  expect_equal(res1, TRUE)


  str2 <- "if (cyl == 4) delete()"


  res2 <- has_output(str2)

  res2

  expect_equal(res2, FALSE)

})


test_that("ds35: Output function can output multiple rows per obs.", {


  d1 <- datastep(mtcars,
                 {

                   fork <- "hello"
                   bork <- "sammy"

                   if (cyl == 4) {
                     seq <- 1
                     output()
                     seq <- 2
                     output()

                   }

                   # Never executed
                   andalso <- "here"

                 })

  d1

  expect_equal(nrow(d1), 22)
  expect_equal(ncol(d1), 14)

})



test_that("ds35: delete and output can be used together.", {


  d1 <- datastep(mtcars,
                 {


                   if (cyl == 4) {
                     delete()

                   }

                   output()

                 })

  d1

  expect_equal(nrow(d1), 21)
  expect_equal(ncol(d1), 11)

})


test_that("ds36: output works with empty dataset.", {

  d1 <- datastep(data.frame(), {

    bork <- 1
    fork <- "one"
    output()

    bork <- 2
    fork <- "two"
    output()

  })

  # print(d1)
  # print(attributes(d1))
  # print(attributes(d1$fork))
  d1

  expect_equal(nrow(d1), 2)
  expect_equal(ncol(d1), 2)
  expect_equal(names(d1), c("bork", "fork"))
  expect_equal(d1[[1, 1]], 1)
  # if ("factor" %in% class(d1[[2, 2]]))
  #   expect_equal(d1[[2, 2]], 2)
  # else
  #   expect_equal(d1[[2, 2]], "two")

})


test_that("ds37: datastep strips and restores extra classes.", {

  d2 <- mtcars

  class(d2) <- c("fork", class(d2))

  d1 <- datastep(d2,
                 {


                   if (cyl == 4) {
                     delete()

                   }


                 })

  d1

  class(d1)

  expect_equal(class(d1), c("fork", "data.frame"))

})

test_that("ds38: no row data frame works with output.", {


  d1 <- subset(mtcars, mtcars$cyl == 10)

  d2 <- datastep(d1, {

    bork <- 1
    fork <- "one"
    output()

    bork <- 2
    fork <- "two"
    output()

  })

  d2

  expect_equal(nrow(d2), 2)
  expect_equal(ncol(d2), 13)

})

test_that("ds39: no row warning works.", {


  d1 <- subset(mtcars, mtcars$cyl == 10)

  expect_warning(datastep(d1, {

    bork <- 1

  }))



})

# Works interactively but not during test_that run
# Not sure what is going on.  Datastep can't find dslst.
# test_that("ds40: output works in loop", {
#
#
#   dslst <- list("mtcars" = mtcars, "beaver1" = beaver1, "iris" = iris)
#
#   # Create metadata
#   res3 <- datastep(data.frame(), {
#
#
#     for (name in names(dslst)) {
#       rows <- nrow(dslst[[name]])
#       cols <- ncol(dslst[[name]])
#       output()
#     }
#
#
#   })
#
#
#   res3
#
#   expect_equal(nrow(res3), 3)
#   expect_equal(ncol(res3), 3)
#
# })

test_that("ds41: perform_set function works.", {

  dat1 <- mtcars[1:10, 1:10]
  dat2 <- mtcars[11:20, 2:11]

  res1 <- perform_set(dat1, dat2)


  res1

  expect_equal(nrow(res1), 20)
  expect_equal(ncol(res1), 11)

  dat1$char <- "top"
  dat2$char <- "middle"
  dat3 <- dat2
  dat3$char <- "bottom"

  res2 <- perform_set(dat1, list(dat2, dat3))


  res2

  expect_equal(nrow(res2), 30)
  expect_equal(ncol(res2), 12)

  dat1$char <- as.factor(dat1$char)
  dat2$char <- as.factor(dat2$char)
  dat3$char <- as.factor(dat3$char)

  res3 <- perform_set(dat1, list(dat2, dat3))


  res3

  expect_equal(nrow(res3), 30)
  expect_equal(ncol(res3), 12)
  expect_equal(levels(res3$char), c("top", "middle", "bottom"))


})


test_that("ds42: perform_merge function works.", {

  dat1 <- read.table(header = TRUE, text = '
    ID NAME
    A01 SUE
    A02 TOM
    A05 KAY
    A10 JIM
  ')

  dat2 <- read.table(header = TRUE, text = '
    ID AGE SEX
    A01 58 F
    A02 20 M
    A05 47 F
    A10 11 M
    A11 23 F
  ')

  dat1
  dat2

  res1 <- perform_merge(dat1, dat2, "ID", NULL)

  res1

  expect_equal(nrow(res1), 5)
  expect_equal(ncol(res1), 4)


  res2 <- perform_merge(dat1, dat2, "ID", c("INA", "INB"))

  res2

  expect_equal(nrow(res2), 5)
  expect_equal(ncol(res2), 6)

  dat3 <- read.table(header = TRUE, text = '
    ID STATUS
    A02 ACTIVE
  ')

  res3 <- perform_merge(dat1, list(dat2, dat3), "ID", c("INA", "INB", "INC"))

  res3

  expect_equal(nrow(res3), 5)
  expect_equal(ncol(res3), 8)

  dat4 <- read.table(header = TRUE, text = '
    ID WEIGHT
    A05 23
  ')

  res4 <- perform_merge(dat1, list(dat2, dat3, dat4),
                        c("ID"),
                        c("INA", "INB", "INC", "IND"))

  res4

  expect_equal(nrow(res4), 5)
  expect_equal(ncol(res4), 10)

  res5 <- perform_merge(dat1, list(dat2, dat3, dat4),
                        c("ID"),
                        c("INA", "INB", "INC"))

  res5

  expect_equal(nrow(res5), 5)
  expect_equal(ncol(res5), 9)



})

test_that("ds43: datastep with merge works.", {

  dat1 <- read.table(header = TRUE, text = '
    ID NAME
    A01 SUE
    A02 TOM
    A05 KAY
    A10 JIM
  ')

  dat2 <- read.table(header = TRUE, text = '
    ID AGE SEX
    A01 58 F
    A02 20 M
    A05 47 F
    A10 11 M
    A11 23 F
  ')

  dat1
  dat2

  res1 <- datastep(dat1, merge = dat2, merge_by = "ID", {})

  res1

  expect_equal(nrow(res1), 5)
  expect_equal(ncol(res1), 4)


  res2 <- datastep(dat1, merge = dat2, merge_by = "ID",
                   merge_in = c("INA", "INB"),
                   where = expression(INA == 1), {})

  res2

  expect_equal(nrow(res2), 4)
  expect_equal(ncol(res2), 6)



  res3 <- datastep(dat1, merge = dat2, merge_by = "ID",
                   merge_in = c("INA", "INB"),
                   where = expression(INA == 0 & INB == 1), {})

  res3

  expect_equal(nrow(res3), 1)
  expect_equal(ncol(res3), 6)



  dat4 <- read.table(header = TRUE, text = '
    NO AGE SEX
    A01 58 F
    A02 20 M
    A05 47 F
    A10 11 M
    A11 23 F
  ')

  dat1
  dat4

  res4 <- datastep(dat1, merge = dat4, merge_by = c("ID" = "NO"), {})

  res4

  expect_equal(nrow(res4), 5)
  expect_equal(ncol(res4), 4)


  expect_error( datastep(dat1, merge = dat4, merge_by = c("IDS" = "NO"), {}))
  expect_error( datastep(dat1, merge = dat4, merge_by = c("ID" = "NUM"), {}))

})

test_that("ds44: datastep with set works.", {

  dat1 <- mtcars[1:10, 1:10]
  dat2 <- mtcars[11:20, 2:11]

  res1 <- datastep(dat1, set = dat2, {})


  res1

  expect_equal(nrow(res1), 20)
  expect_equal(ncol(res1), 11)


})


test_that("ds45: keep and drop checks work.", {

  res1 <- datastep(mtcars, keep = c("mpg", "cyl", "fork"), {})

  expect_equal(ncol(res1), 2)

  res2 <- datastep(mtcars, drop = c("mpg", "cyl", "fork"), {})

  expect_equal(ncol(res2), 9)

})

test_that("ds44: Make sure cols not dropped.", {

  dat1 <- read.table(header = TRUE, text = '
      NAME ID SEX
      SUE A01   O
      TOM A02   O
      KAY A05   O
      JIM A10   O
    ')

  dat2 <- read.table(header = TRUE, text = '
      ID AGE SEX
      A01 58 F
      A02 20 M
      A05 47 F
      A10 11 M
      A11 23 F
    ')

  dat1
  dat2


  res1 <- datastep(dat1, merge = dat2, merge_by = "ID", {})


  res1

  expect_equal(nrow(res1), 5)
  expect_equal(ncol(res1), 5)

})

test_that("ds46: fix_names works as expected.", {

  v1 <- c("A", "B", "C", "D")
  v2 <- c("A", "E", "B", "F")
  ky <- "A"
  sfx <- c(".1", ".2")

  res <- fix_names(v1, v2, ky, sfx)

  res

  expect_equal(res, c("A", "B.1", "C", "D", "E", "B.2", "F"))

})

test_that("ds47: column append with no merge_by works equal rows.", {

  dat1 <- read.table(header = TRUE, text = '
      NAME ID SEX
      SUE A01   O
      TOM A02   O
      KAY A05   O
      JIM A10   O
    ')

  dat2 <- read.table(header = TRUE, text = '
      ID AGE SEX
      A01 58 F
      A02 20 M
      A05 47 F
      A10 11 M
    ')

  dat1
  dat2


  res1 <- datastep(dat1, merge = dat2, {})


  res1

  expect_equal(nrow(res1), 4)
  expect_equal(ncol(res1), 6)
  expect_equal(names(res1), c("NAME", "ID.1", "SEX.1", "ID.2", "AGE", "SEX.2"))

})

test_that("ds48: column append with no merge_by works unequal rows.", {

  dat1 <- read.table(header = TRUE, text = '
      NAME ID SEX
      SUE A01   O
      TOM A02   O
      KAY A05   O
      JIM A10   O
    ')

  dat2 <- read.table(header = TRUE, text = '
      ID AGE SEX
      A01 58 F
      A02 20 M
      A05 47 F
    ')

  dat1
  dat2


  res1 <- datastep(dat1, merge = dat2, {})


  res1

  expect_equal(nrow(res1), 4)
  expect_equal(ncol(res1), 6)
  expect_equal(names(res1), c("NAME", "ID.1", "SEX.1", "ID.2", "AGE", "SEX.2"))

})

test_that("ds49: fill_missing() works as expected.", {

  dat2 <- read.table(header = TRUE, text = '
      ID AGE SEX
      A01 58 F
      A02 20 M
      A05 47 F
    ')

  res1 <- fill_missing(dat2, 4)

  res1

  expect_equal(nrow(res1), 4)

  res2 <- fill_missing(dat2, 10)

  res2

  expect_equal(nrow(res2), 10)

  res3 <- fill_missing(dat2, 2)

  res3

  expect_equal(nrow(res3), 3)

})


test_that("ds50: copy_df_attributes works as expected.", {

  library(tibble)

  dat1 <- as_tibble(mtcars[1:10, c("mpg", "cyl", "disp")])
  labels(dat1) <- list(mpg = "Miles per gallon",
                       cyl = "Cylinders",
                       disp = "Displacement")

  dat2 <- mtcars[11:25, c("mpg", "cyl", "disp")]

  res1 <- copy_df_attributes(dat1, dat2)

  res1

  expect_equal(rownames(res1)[1], "Merc 280C")
  expect_equal("tbl_df" %in% class(res1), TRUE)

})

test_that("ds51: Set keeps dataset attributes.", {

  library(tibble)

  dat1 <- as_tibble(mtcars[1:10, c("mpg", "cyl", "disp")])
  labels(dat1) <- list(mpg = "Miles per gallon",
                       cyl = "Cylinders",
                       disp = "Displacement")

  dat2 <- as_tibble(mtcars[11:20, c("mpg", "cyl", "disp")])


  res1 <- datastep(dat1, set = dat2, {})

  res1

  expect_equal("tbl_df" %in% class(res1), TRUE)
  expect_equal(rownames(res1)[1], "1")

  lbls <- labels(res1)

  expect_equal(lbls[[1]], "Miles per gallon")
  expect_equal(lbls[[2]], "Cylinders")
  expect_equal(lbls[[3]], "Displacement")

})

test_that("ds52: Merge append keeps dataset attributes.", {

  library(tibble)

  dat1 <- as_tibble(mtcars[1:10, c("mpg", "cyl", "disp")])
  labels(dat1) <- list(mpg = "Miles per gallon",
                       cyl = "Cylinders",
                       disp = "Displacement")

  dat2 <- as_tibble(mtcars[11:20, c("hp", "drat", "wt")])
  labels(dat2) <- list(hp = "Horsepower",
                       wt = "Weight")

  res1 <- datastep(dat1, merge = dat2, {})

  res1

  expect_equal("tbl_df" %in% class(res1), TRUE)
  expect_equal(rownames(res1)[1], "1")

  lbls <- labels(res1)

  lbls

  expect_equal(lbls[[1]], "Miles per gallon")
  expect_equal(lbls[[2]], "Cylinders")
  expect_equal(lbls[[3]], "Displacement")

})


test_that("ds53: Merge by keeps dataset attributes.", {

  library(tibble)

  dat1 <- as_tibble(mtcars[1:10, c("mpg", "cyl", "disp")])
  labels(dat1) <- list(mpg = "Miles per gallon",
                       cyl = "Cylinders",
                       disp = "Displacement")

  dat2 <- tibble(cyl = c(4, 6, 8),
                 lbl = c("4 Cylinders",
                         "6 Cylinders",
                         "8 Cylinders"),
                 disp = rep(1, 2, 3))

  labels(dat2) <- list(cyl = "Cylinders",
                       lbl = "Label",
                       disp = "Displacement 2")

  res1 <- datastep(dat1, merge = dat2, merge_by = cyl,{
          sammy <- mpg * 2
    })

  res1

  expect_equal("tbl_df" %in% class(res1), TRUE)
  expect_equal(rownames(res1)[1], "1")

  lbls <- labels(res1)

  lbls

  expect_equal(lbls[[1]], "Miles per gallon")
  expect_equal(lbls[[2]], "Cylinders")
  expect_equal(lbls[[3]], "Displacement")
  expect_equal(lbls[[4]], "Label")
  expect_equal(lbls[[5]], "Displacement 2")

})


test_that("ds43: datastep join works.", {

  dat1 <- read.table(header = TRUE, text = '
    ID NAME
    A01 SUE
    A02 TOM
  ')

  dat2 <- read.table(header = TRUE, text = '
    ID AGE SEX CODE
    A01 58 F    A01
    A02 20 M    A02
    A01 47 F    A01
    A02 11 M    A02
    A01 23 F    A01
  ')

  dat1
  dat2

  res1 <- datastep(dat1, merge = dat2, merge_by = "ID", {})

  res1

  expect_equal(nrow(res1), 5)
  expect_equal(ncol(res1), 5)

  res2 <- datastep(dat1, merge = dat2, merge_by = c(ID = "CODE"), {})


  expect_equal(nrow(res2), 5)
  expect_equal(ncol(res2), 5)

})

test_that("ds44: datastep multiple renames works.", {


  dat2 <- read.table(header = TRUE, text = '
    ID AGE SEX CODE
    A01 58 F    A01
    A02 20 M    A02
    A01 47 F    A01
    A02 11 M    A02
    A01 23 F    A01
  ')

  dat2

  res2 <- datastep(dat2,
                   rename = c(AGE = "TITLE", SEX = "FORK"),{})

  res2
  expect_equal(nrow(res2), 5)
  expect_equal(ncol(res2), 4)
  expect_equal(names(res2), c("ID", "TITLE", "FORK", "CODE"))

})


test_that("ds43: Merge dataset names are not 'fixed' when using tibbles.", {

  library(tibble)

  dat1 <- read.table(header = TRUE, text = '
    ID2 NAME
    A01 SUE
    A02 TOM
  ')

  dat2 <- read.table(header = TRUE, text = '
    ID "AGE 1" "SEX 2" "CODE 4"
    A01 58 F    A01
    A02 20 M    A02
    A01 47 F    A01
    A02 11 M    A02
    A01 23 F    A01
  ', check.names = FALSE)

  dat1 <- as_tibble(dat1)
  dat2 <- as_tibble(dat2)


  res1 <- datastep(dat2, merge = dat1, merge_by = c("ID" = "ID2"), {},
                   log = FALSE)

  res1

  expect_equal(nrow(res1), 5)
  expect_equal(ncol(res1), 5)
  expect_equal(names(res1), c("ID", "AGE 1", "SEX 2", "CODE 4", "NAME"))

})


test_that("ds44: Merge works with factors.", {


  # Create sample data
  grp1 <- read.table(header = TRUE, text = '
    GROUP  NAME
    G01  Group1
    G02  Group2
  ', stringsAsFactors = TRUE)

  grp2 <- read.table(header = TRUE, text = '
    GROUP  NAME
    G03  Group3
    G04  Group4
  ', stringsAsFactors = TRUE)

  dat <- read.table(header = TRUE, text = '
    ID AGE SEX GROUP
    A01 58 F    G01
    A02 20 M    G02
    A03 47 F    G05
    A04 11 M    G03
    A05 23 F    G01
  ', stringsAsFactors = TRUE)

  # Set operation
  grps <- datastep(grp1, set = grp2, {})
  grps


  # Merge operation - Outer Join
  res <- datastep(dat, merge = grps,
                  merge_by = "GROUP",
                  merge_in = c("inA", "inB"), {})


  expect_equal(nrow(res), 6)
  expect_equal(ncol(res), 7)

})


test_that("ds45: Output function works as expected when the names have spaces.", {


  dat <- mtcars[ , c("mpg", "cyl")]

  rownames(dat) <- NULL
  names(dat) <- c("miles per gallon", "cylinders")


  d1 <- datastep(dat,
                 {

                   if (cylinders == 4) {
                     output()
                     #fork <- 1
                   }

                 })

  d1

  expect_equal(nrow(d1), 11)
  expect_equal(ncol(d1), 2)

})

test_that("ds46: Skip loop when there is no code.", {


  dat <- mtcars[ , c("mpg", "cyl")]



  d1 <- datastep(dat, where = expression(cyl == 4),
                 {})

  d1

  expect_equal(nrow(d1), 11)
  expect_equal(ncol(d1), 2)

})


test_that("ds47: Multiple group bys works as expected.", {

  libname(dat, base_path, "rds")

  lib_load(dat)


  dt <- sort(dat.demo_studya, by = c("treatment", "sex"))

  d1 <- datastep(dt, by = c("treatment", "sex"), {

    f1 <- first.
    l1 <- last.

    f2 <- first.treatment
    l2 <- last.treatment

    f3 <- first.sex
    l3 <- last.sex

  }, sort_check = TRUE)

  d1

  expect_equal(sum(d1$f1), 4)
  expect_equal(sum(d1$l1), 4)
  expect_equal(sum(d1$f2), 2)
  expect_equal(sum(d1$l2), 2)
  expect_equal(sum(d1$f2), 2)
  expect_equal(sum(d1$l2), 2)

})


test_that("ds48: labels retained with where clause.", {


  dat <- mtcars

  labels(dat) <- list(mpg = "Miles", cyl = "Cylinders")

  df <- datastep(dat,
                 where = expression(cyl == 8),
                 {

                   if (mpg >= 20)
                     mpgcat <- "High"
                   else
                     mpgcat <- "Low"

                   recdt <- as.Date("1974-06-10")

                   if (cyl == 8)
                     is8cyl <- TRUE
                   else
                     is8cyl <- FALSE

                 })

  df

  lbls <- labels(df)

  expect_equal(length(lbls), 2)

})

test_that("ds49: works as expected with local variable.", {
  
  
  library(fmtr)
    
  myfmt <- value(condition(x >= 20, "High"),
                 condition(x < 20, "Low"))
  
  # format = list(mpg=myfmt), 
  
  d1 <- datastep(mtcars, {
    
    mpgcat <- fapply(mpg, myfmt)
    
  })
  
  d1
  
  
  expect_equal("mpgcat" %in% names(d1), TRUE)
  expect_equal(d1$mpgcat[1], "High")
  
})


test_that("ds50: works as expected with source.all().", {

  
  if (dev) {

    pth <- file.path(dirname(base_path), "programs")
  
  
    res <- common::source.all(pth)
  
  
    expect_equal(res$Status, 0)
  
  } else {
    
   expect_equal(TRUE, TRUE) 
  }

})


test_that("ds51: delete() works with NA in data frame.", {
  
  
  df1 <- data.frame(
    var = c(NA,0),
    bar = c(0, 1)
  )
  
  
  datastep(df1,
           {
             if (var %eq% 0) {
               delete() 
             }
           }) -> df2
  
  
  expect_equal(TRUE, TRUE)

})

context("Datastep Performance Tests")

base_path <- "c:\\packages\\libr\\tests\\testthat\\data"

base_path <- "./data"

DEV <- FALSE


test_that("add_autos() function works as expected", {
  
  libname(dat, file.path(base_path, "SDTM"), "sas7bdat")

  tm <- Sys.time()
  
  dat3 <- add_autos(dat$lb, c("USUBJID", "LBCAT", "LBTESTCD"))
  
  
  tmdiff <- Sys.time() - tm
  tmdiff
  
  expect_equal("first." %in% names(dat3), TRUE)
  expect_equal("last." %in% names(dat3), TRUE)

})

test_that("sort check works as expected", {

  dat3 <- add_autos(mtcars, c("am"), sort_check = FALSE)
  

  expect_equal("first." %in% names(dat3), TRUE)
  expect_equal("last." %in% names(dat3), TRUE)
  expect_error( add_autos(mtcars, c("am"), sort_check = TRUE))
})


# Baseline of 10 sec on condition
test_that("datastep() performance is good", {
  
  if (DEV) {
    
    libname(dat, file.path(base_path, "SDTM"), "sas7bdat")

    
    tm <- Sys.time()
    
    res <- datastep(dat$lb, 
                    {
                      if (is.na(LBBLFL))
                        blisna <- TRUE
                      else
                        blisna <- FALSE
                      
                      
                    })
    
    tmdiff <- Sys.time() - tm
    tmdiff
    
    expect_equal(tmdiff < 10, TRUE)
    
  } else
    expect_equal(TRUE, TRUE)
  
})

# Jumps to 14 seconds when retain added
test_that("datastep() performance with retain is good", {
  
  
  libname(dat, file.path(base_path, "SDTM"), "sas7bdat")
  
  
  if (DEV) {
    
    libname(dat, file.path(base_path, "SDTM"), "sas7bdat")
    
    
    tm <- Sys.time()
    
    res <- datastep(dat$lb, retain = list(rnum = 0),
                    {
                      if (is.na(LBBLFL))
                        subjstart <- TRUE
                      else
                        subjstart <- FALSE
                      
                      rnum <- 2 + 1
                      
                    })
    
    tmdiff <- Sys.time() - tm
    tmdiff
    
    expect_equal(tmdiff < 14, TRUE)
    
  } else
    expect_equal(TRUE, TRUE)
  
})

# Still less than < 11 seconds when group by added
test_that("datastep() performance with by group is good", {
  
  if (DEV) {
    
    libname(dat, file.path(base_path, "SDTM"), "sas7bdat")
    
    
    tm <- Sys.time()
    
    res <- datastep(dat$lb, 
                    by = c("USUBJID"),
                    {
                      if (first.)
                        subjstart <- TRUE
                      else
                        subjstart <- FALSE
                      
                    #  rnum <- rnum + 1
                      
                    })
    
    tmdiff <- Sys.time() - tm
    tmdiff
    
    expect_equal(tmdiff < 11, TRUE)
    
  } else
    expect_equal(TRUE, TRUE)
  
})

# Jumps to 14 seconds when retain and group by added
test_that("datastep() performance with retain is good", {
  
  if (DEV) {
    
    libname(dat, file.path(base_path, "SDTM"), "sas7bdat")
    
    tm <- Sys.time()
  
    
    res <- datastep(dat$lb, retain = list(rnum = 0),
                    by = c("USUBJID", "LBCAT", "LBTESTCD"),
                    {
                      if (first.)
                        subjstart <- TRUE
                      else
                        subjstart <- FALSE
                      
                      rnum <- rnum + 1
                      
                      rnum2 <- n.
                      
                    }, sort_check = TRUE)
    
    tmdiff <- Sys.time() - tm
    tmdiff
    
    expect_equal(tmdiff < 16, TRUE)
    
  } else
    expect_equal(TRUE, TRUE)
  
})


test_that("datastep() with group_by performance is good", {
  
  if (DEV) {
    
    library(dplyr)
    
    scs <- specs(PE = import_spec(PESTAT = "character"))
    
    libname(dat, file.path(base_path, "SDTM"), "csv", import_specs = scs)
    
    tm <- Sys.time()
    
    prep <- dat$DM %>% 
      left_join(dat$VS, by = c("USUBJID" = "USUBJID")) %>% 
      select(USUBJID, VSTESTCD, VISIT, VISITNUM, VSSTRESN, ARM, VSBLFL) %>% 
      filter(VSTESTCD %in% c("PULSE", "RESP", "TEMP", "DIABP", "SYSBP"), 
             !(VISIT == "SCREENING" & VSBLFL != "Y")) %>% 
      arrange(USUBJID, VSTESTCD, VISITNUM) %>% 
      group_by(USUBJID, VSTESTCD) %>%
      #datastep(by = c("USUBJID", "VSTESTCD"), retain = list(BSTRESN = 0), {
      datastep(retain = list(BSTRESN = 0), {
        
        # Combine treatment groups
        # And distingish baseline time points
        if (ARM == "ARM A") {
          
          if (VSBLFL %eq% "Y") {
            GRP <- "A_BASE"
          } else {
            GRP <- "A_TRT"
          }
          
        } else {
          
          if (VSBLFL %eq% "Y") {
            GRP <- "O_BASE"
          } else {
            GRP <- "O_TRT"
          }
          
        }
        
        # Populate baseline value
        if (first.)
          BSTRESN = VSSTRESN
        
      })
    
    tmdiff <- Sys.time() - tm 
    tmdiff
    
    expect_equal(tmdiff < 3, TRUE)
    
  } else 
    expect_equal(TRUE, TRUE)
  
})


test_that("100,000 row datastep on data.frame is good.", {
  
  if (DEV) {
    
    l <- 100000
    
    df <- data.frame(C1 = seq_len(l), C2 = runif(l), 
                     C3 = runif(l), C4 = runif(l), stringsAsFactors = FALSE)
    
    tm <- Sys.time()
    
    res <- datastep(df, attrib = list(C5 = 0, C6 = 0),
                    {
                      C5 <- C2 + C3 + C4
                      C6 <- max(C2, C3, C4)
                      
                    })
    
    
    tmdiff <- Sys.time() - tm
    tmdiff
    
    res[1:10, ]
    
    expect_equal(tmdiff < 30, TRUE)
    
    # 100,000 rows is 20 seconds
    # 1,000,000 rows is 3.6 minutes
    
  } else
    expect_equal(TRUE, TRUE)
  
})


test_that("100,000 row datastep on tibble is good.", {
  
  if (DEV) {
    
    library(tibble)
    
    l <- 100000
    
    df <- tibble(C1 = seq_len(l), C2 = runif(l), 
                     C3 = runif(l), C4 = runif(l))
    
    tm <- Sys.time()
    
    res <- datastep(df, attrib = list(C5 = 0, C6 = 0),
                    {
                      C5 <- C2 + C3 + C4
                      C6 <- max(C2, C3, C4)
                      
                    })
    
    
    tmdiff <- Sys.time() - tm
    tmdiff
    
    res[1:10, ]
    
    expect_equal(tmdiff < 30, TRUE)
    
    # 100,000 rows is 21.2 seconds
    # 1,000,000 rows is 3.8 minutes
    
  } else
    expect_equal(TRUE, TRUE)
  
})



test_that("100,000 row datastep on data.table is good.", {
  
  if (DEV) {
    
    library(data.table)
    
    l <- 100000
    
    df <- data.table(C1 = seq_len(l), C2 = runif(l), 
                 C3 = runif(l), C4 = runif(l))
    
    tm <- Sys.time()
    
    res <- datastep(df, attrib = list(C5 = 0, C6 = 0),
                    {
                      C5 <- C2 + C3 + C4
                      C6 <- max(C2, C3, C4)
                      
                    })
    
    
    tmdiff <- Sys.time() - tm
    tmdiff
    
    res[1:10, ]
    
    expect_equal(tmdiff < 30, TRUE)
    
    # 100,000 rows is 1.3 minutes with out modification to datastep
    # 100,000 rows is 22.3 seconds after modification 
    # 1,000,000 rows not going to try
    
  } else
    expect_equal(TRUE, TRUE)
  
})


test_that("complex datastep() performance is good", {
  
  if (DEV) {
    
    library(dplyr)
    
    scs <- specs(PE = import_spec(PESTAT = "character"))
    
    libname(dat, file.path(base_path, "SDTM"), "csv", import_specs = scs, 
            quiet = TRUE)
    
    tm <- Sys.time()
    
    prep <- dat$DM %>% 
      left_join(dat$VS, by = c("USUBJID" = "USUBJID")) %>% 
      select(USUBJID, VSTESTCD, VISIT, VISITNUM, VSSTRESN, ARM, VSBLFL) %>% 
      filter(VSTESTCD %in% c("PULSE", "RESP", "TEMP", "DIABP", "SYSBP"), 
             !(VISIT == "SCREENING" & VSBLFL != "Y")) %>% 
      arrange(USUBJID, VSTESTCD, VISITNUM) %>% 
      group_by(USUBJID, VSTESTCD) %>%
      datastep(by = c("USUBJID", "VSTESTCD"), retain = list(BSTRESN = 0), {
        
        # Combine treatment groups
        # And distingish baseline time points
        if (ARM == "ARM A") {
          
          if (VSBLFL %eq% "Y") {
            GRP <- "A_BASE"
          } else {
            GRP <- "A_TRT"
          }
          
        } else {
          
          if (VSBLFL %eq% "Y") {
            GRP <- "O_BASE"
          } else {
            GRP <- "O_TRT"
          }
          
        }
        
        # Populate baseline value
        if (first.)
          BSTRESN = VSSTRESN
        
      })
    
    tmdiff <- Sys.time() - tm 
    tmdiff
    
    expect_equal(tmdiff < 3, TRUE)
    
  } else 
    expect_equal(TRUE, TRUE)
  
})

context("Dictionary Tests")

base_path <- "c:\\packages\\libr\\tests\\testthat\\data"

base_path <- "./data"

dev <- FALSE

test_that("dict1: getDictionary() function works as expected.", {
  
  crs <- data.frame(name = rownames(mtcars), mtcars, stringsAsFactors = FALSE)
  
  attr(crs$name, "label") <- "Car Name"
  attr(crs$name, "description") <- "Derived from rownames"
  crs$type <- ifelse(crs$mpg > 20, "High", "Low")
  attr(crs$mpg, "format") <- "%.1f"
  
  res <- getDictionary(crs, "crs")

  expect_equal(nrow(res), 13)
  expect_equal(as.character(res[1, "Label"]), "Car Name")
  expect_equal(as.character(res[1, "Description"]), "Derived from rownames")
  expect_equal(res[13, "MaxChar"], 4)
  
})



test_that("dict2: dictionary() function works as expected with df.", {
  
  crs <- data.frame(name = rownames(mtcars), mtcars, stringsAsFactors = FALSE)
  
  attr(crs$name, "label") <- "Car Name"
  attr(crs$name, "description") <- "Derived from rownames"
  crs$type <- ifelse(crs$mpg > 20, "High", "Low")
  attr(crs$mpg, "format") <- "%.1f"
  
  res <- dictionary(crs)
  
  expect_equal(nrow(res), 13)
  
})



test_that("dict3: dictionary() function works as expected with tibble.", {
  
  library(tibble)
  
  crs <- tibble(name = rownames(mtcars), mtcars)
  
  attr(crs$name, "label") <- "Car Name"
  attr(crs$name, "description") <- "Derived from rownames"
  crs$type <- ifelse(crs$mpg > 20, "High", "Low")
  attr(crs$mpg, "format") <- "%.1f"
  attr(crs$hp, "justify") <- "left"
  
  res <- dictionary(crs)
  
  expect_equal(nrow(res), 13)
  
})


test_that("dict4: dictionary() function works as expected with lib.", {
  
  crs <- data.frame(name = rownames(mtcars), mtcars, stringsAsFactors = FALSE)
  
  attr(crs$name, "label") <- "Car Name"
  attr(crs$name, "description") <- "Derived from rownames"
  crs$type <- ifelse(crs$mpg > 20, "High", "Low")
  attr(crs$mpg, "format") <- "%.1f"
  attr(crs$name, "justify") <- "left"
  
  dat <- libname(dat, tempdir())
  
  dat <- lib_add(dat, crs)
  dat <- lib_add(dat, iris)
  dat <- lib_add(dat, beaver1)
  
  res <- dictionary(dat)
  
  expect_equal(nrow(res), 22)
  
  
  lib_delete(dat)
})



test_that("dict5: dictionary() function works as expected with df and standard_eval.", {
  
  
  options("libr.standard_eval" = TRUE)
  
  crs <- data.frame(name = rownames(mtcars), mtcars, stringsAsFactors = FALSE)
  
  attr(crs$name, "label") <- "Car Name"
  attr(crs$name, "description") <- "Derived from rownames"
  crs$type <- ifelse(crs$mpg > 20, "High", "Low")
  attr(crs$mpg, "format") <- "%.1f"
  
  res <- dictionary(crs)
  
  expect_equal(nrow(res), 13)
  
  options("libr.standard_eval" = FALSE)
  
})


test_that("dict6: dictionary() function works as expected with lib.", {
  
  options("libr.standard_eval" = TRUE)
  
  crs <- data.frame(name = rownames(mtcars), mtcars, stringsAsFactors = FALSE)
  
  attr(crs$name, "label") <- "Car Name"
  attr(crs$name, "description") <- "Derived from rownames"
  crs$type <- ifelse(crs$mpg > 20, "High", "Low")
  attr(crs$mpg, "format") <- "%.1f"
  attr(crs$name, "justify") <- "left"
  
  dat <- libname(dat, tempdir())
  
  dat <- lib_add(dat, crs)
  dat <- lib_add(dat, iris)
  dat <- lib_add(dat, beaver1)
  
  res <- dictionary(dat)
  
  res
  expect_equal(nrow(res), 22)
  
  
  lib_delete(dat)
  
  options("libr.standard_eval" = FALSE)
})


test_that("dict7: dictionary() parameter checks work as expected.", {
  
  f <- "fork"
  
  expect_error(dictionary(f))
  
  
})

test_that("dict8: dictionary() widths work as expected when width attribute set.", {
  
  crs <- data.frame(name = rownames(mtcars), mtcars, fork = "fork",
                    stringsAsFactors = FALSE)
  
  attr(crs$name, "width") <- 4
  attr(crs$name, "description") <- "Derived from rownames"

  
  res <- dictionary(crs)
  
  res
  
  expect_equal(res$Width[1], 4)  
  expect_equal(is.na(res$Width[13]), TRUE) 
  
})

test_that("dict9: dictionary() widths work as expected when width attribute not set.", {
  
  crs <- data.frame(name = rownames(mtcars), mtcars, fork = "fork", 
                    stringsAsFactors = FALSE)
  
  #attr(crs$name, "width") <- 4
  attr(crs$name, "description") <- "Derived from rownames"
  
  
  res <- dictionary(crs)
  
  res
  
  expect_equal(is.na(res$Width[1]), TRUE)  
  expect_equal(is.na(res$Width[13]), TRUE) 
  expect_equal(res$MaxChar[1], 19)  
  expect_equal(res$MaxChar[13], 4) 
  
})

test_that("dict10: dictionary() function works as expected with user-defined format.", {
  
  if (dev) {
    
    library(fmtr)
    
    fmt <- value(condition(x == 4, "A"),
                 condition(x == 8, "B"),
                 condition(TRUE, "C"))
    
    
    crs <- data.frame(name = rownames(mtcars), mtcars, stringsAsFactors = FALSE)
    
    fapply(crs$cyl, fmt)
    
    attr(crs$cyl, "format") <- fmt 
    
    # Shouldn't get an error
    res <- dictionary(crs)
    
    expect_equal(nrow(res), 12)
  
  } else
    expect_equal(TRUE, TRUE)
  
})

test_that("dict11: dictionary() function works with standard libname.", {
  
  
  if (dev) {
    libname(tst, file.path(base_path, "SDTM"), "csv")
    
    # Shouldn't get error here.
    d <- dictionary(tst)
    
    
    d
  
  } 
  
  expect_equal(TRUE, TRUE)
  
})

test_that("dict12: dictionary() function has no errors if data frame has no rows.", {
  
  crs <- data.frame(name = rownames(mtcars), mtcars, stringsAsFactors = FALSE)
  
  attr(crs$name, "label") <- "Car Name"
  attr(crs$name, "description") <- "Derived from rownames"
  crs$type <- ifelse(crs$mpg > 20, "High", "Low")
  attr(crs$mpg, "format") <- "%.1f"
  
  res <- dictionary(crs[0, ])
  
  expect_equal(nrow(res), 13)
  
})

context("Specs Tests")

base_path <- "c:\\packages\\libr\\tests\\testthat\\data"

base_path <- "./data"


test_that("import_spec() function works as expected.", {
  
  is <- import_spec(col1 = "character", col2 = "integer",
                   na = c("NA", ""),
                   trim_ws = FALSE)
  
  expect_equal(is$col_types, list(col1 = "character", col2 = "integer"))
  expect_equal(is$na, c("NA", ""))
  expect_equal(is$trim_ws, FALSE)
  
})

test_that("specs() function works as expected.", {
  
  is1 <- import_spec(col1 = "character", col2 = "integer",
                     na = c("NA", "-"),
                     trim_ws = FALSE)
  
  is2 <- import_spec(col1 = "numeric", col2 = "date:%d%m%Y",
                     na = c(" ", ""),
                     trim_ws = TRUE)
  spcs <- specs(na = c("NA", "-", " ", ""),
               trim_ws = TRUE, AB = is1, AC = is2)
  
  expect_equal(length(spcs$specs), 2)
  expect_equal(spcs$na, c("NA", "-", " ", ""))
  expect_equal(spcs$trim_ws, TRUE)
  expect_equal(spcs$specs$AB$trim_ws, FALSE)
  expect_equal(spcs$specs$AB$col_types[[1]], "character")
  expect_equal(spcs$specs$AC$col_types[[1]], "numeric")
  
  s1 <- capture.output(print(spcs))
  expect_equal(length(s1) > 0, TRUE)
  
  s2 <- capture.output(print(spcs, verbose = TRUE))
  expect_equal(length(s1) > 0, TRUE)
  
})


test_that("write_specs() and read_specs() functions works as expected.", {
  
  is1 <- import_spec(col1 = "character", col2 = "integer",
                     na = c("NA", "-"),
                     trim_ws = FALSE)
  
  is2 <- import_spec(col1 = "numeric", col2 = "date:%d%m%Y",
                     na = c(" ", ""),
                     trim_ws = TRUE)
  spcs <- specs(na = c("NA", "-", " ", ""),
                trim_ws = TRUE, AB = is1, AC = is2)
  
  tmp <- tempdir()
  pth2 <- write.specs(spcs, tmp)
  
  fe <- file.exists(file.path(tmp, "spcs.specs"))
  expect_equal(fe, TRUE)

  
  spcs2 <- read.specs(pth2)
  
  
  expect_equal(length(spcs2$specs), 2)
  expect_equal(spcs2$na, c("NA", "-", " ", ""))
  expect_equal(spcs2$trim_ws, TRUE)
  expect_equal(spcs2$specs$AB$trim_ws, FALSE)
  expect_equal(spcs2$specs$AB$col_types[[1]], "character")
  expect_equal(spcs2$specs$AC$col_types[[1]], "numeric")
  
  spcs3 <- read.specs(tmp)
  expect_equal(length(spcs3$specs), 2)
  
  expect_error(write.specs("fork"))
  expect_error(read.specs("fork"))
  
  if (fe)
    unlink(pth2)
  
})

test_that("get_colspec_xlsx() works as expected.", {
  
  expect_error(get_colspec_xlsx(c(one = "character", 
                       two = "integer", 
                       four = "date:%d%m%y"),
                     5, c("one", "two", "three", "four")))
  
  res <- get_colspec_xlsx(c(one = "character", 
                       two = "integer", 
                       four = "date:%d%m%y"),
                     4, c("one", "two", "three", "four"))

  expect_equal(res[["one"]], "text")
  expect_equal(res[["two"]], "numeric")
  expect_equal(res[["three"]], "guess")
  expect_equal(res[["four"]], "date")
  
})

test_that("get_colspec_csv() works as expected.", {
  
  res <- get_colspec_csv(c(one = "character", 
                       two = "integer", 
                       four = "date=%d%m%y",
                       five = "numeric",
                       six = "guess",
                       seven = "time=%H:%M:%S",
                       eight = "datetime=%d%m%y %H:%M:%S",
                       nine = "logical"))
  
  expect_equal(res$cols[["one"]], col_character())
  expect_equal(res$cols[["two"]], col_integer())
  expect_equal(is.null(res$cols[["three"]]), TRUE)
  expect_equal(res$cols[["four"]], col_date(format = "%d%m%y"))
  expect_equal(res$cols[["five"]], col_double())
  expect_equal(res$cols[["six"]], col_guess())
  expect_equal(res$cols[["seven"]], col_time(format = "%H:%M:%S"))
  expect_equal(res$cols[["eight"]], col_datetime(format = "%d%m%y %H:%M:%S"))
  expect_equal(res$cols[["nine"]], col_logical())
  
})


test_that("libname works on PE data for csv.", {
  
  lst <- specs(PE = import_spec(PESTAT = "character",
                                na = ""))
  
  libname(dat, file.path(base_path, "PE"), "csv", import_specs = lst)
  

  expect_equal(length(dat), 1)
  

})

test_that("libname works on PE data for xlsx.", {
  
  lst <- specs(PE = import_spec(PESTAT = "character",
                                na = "NA"))
  
  
  libname(dat, file.path(base_path, "PE"), "xlsx", import_specs = lst)
  

  expect_equal(length(dat), 1)
  
  
})

test_that("libname works on PE data for xls.", {
  
  lst <- specs(PE = import_spec(PESTAT = "character",
                                na = ""))
  
  
  libname(dat, file.path(base_path, "PE"), "xls", import_specs = lst)
  
  
  expect_equal(length(dat), 1)
  
  
})

test_that("writing xls changes to xlsx.", {
  
  tmp <- tempdir()
  
  libname(dat, tmp, "xls")
  
  lib_add(dat, mtcars)
  
  
  fe <- file.exists(file.path(tmp, "mtcars.xlsx"))
  expect_equal(fe, TRUE)
  
  lib_delete(dat)
  
})

test_that("libname works on SDTM data for csv.", {
  
  lst <- specs(PE = import_spec(PESTAT = "character",
                                na = ""))
  
  
  libname(dat, file.path(base_path, "SDTM"), "csv", import_specs = lst)
  
  expect_equal(length(dat), 13)
  
})

test_that("libname works on SDTM data for sas7bdat.", {
  
  

  libname(dat, file.path(base_path, "SDTM"), "sas7bdat")
  

  expect_equal(length(dat), 13)

})


test_that("import_specs works as expected with dates.", {
  
  library(readr)

  # Create temp path
  tmp <- file.path(tempdir(), "mtcars.csv")

  # Create data for illustration purposes
  df <- data.frame(vehicle = rownames(mtcars), mtcars[c("mpg", "cyl", "disp")], 
                   stringsAsFactors = FALSE)

  # Kill rownames
  rownames(df) <- NULL

  # Add some columns
  df <- df[1:10, ] %>%
    datastep({

      recdt <- "10JUN1974"

      if (mpg >= 20)
        mpgcat <- "High"
      else
        mpgcat <- "Low"

      if (cyl == 8)
        cyl8 <- TRUE

    })

  df

  # Save to temp directory
  write_csv(df, tmp)

  # Create import spec
  spcs <- specs(mtcars = import_spec(vehicle = "character",
                                     cyl = "integer",
                                     recdt = "date=%d%b%Y",
                                     mpgcat = "guess",
                                     cyl8 = "logical"))

  # Create library
  libname(dat, tempdir(), "csv", import_specs = spcs)

  # View data types
  dictionary(dat)
  
  expect_equal(class(dat$mtcars$recdt), "Date")
  
})


test_that("no specs work on CRF data for sas7bdat.", {
  
  
  libname(dat, file.path(base_path, "CRF"), "sas7bdat")
  
  expect_equal(class(dat$dm$VISITREP), "logical")
  expect_equal(class(dat$pe$VISITREP), "logical")
  expect_equal(all(is.na(dat$dm$VISITREP)), TRUE)
  expect_equal(all(is.na(dat$pe$VISITREP)), TRUE)
  
})

test_that("specs na and trim_ws work on CRF data for sas7bdat.", {
  
  lst <- specs(na = c("", "."), trim_ws = TRUE)
                              
  
  libname(dat, file.path(base_path, "CRF"), "sas7bdat", import_specs = lst)
  
  # dat$dm  
  # dat$pe
  
  expect_equal(class(dat$dm$VISITREP), "logical")
  expect_equal(class(dat$dm$VISITREP), "logical")
  
})


test_that("dm import_spec na and trim_ws work on CRF data for sas7bdat.", {
  
  lst <- specs(dm = import_spec(na = c("", "."), trim_ws = TRUE))
  
  
  libname(dat, file.path(base_path, "CRF"), "sas7bdat", import_specs = lst)
  
   # dat$dm  
   # dat$pe
  
  expect_equal(class(dat$dm$VISITREP), "logical")
  expect_equal(class(dat$pe$VISITREP), "character")
  
})


test_that("dm and pe import_spec col_types work on CRF data for sas7bdat.", {
  
  lst <- specs(dm = import_spec(VISITREP = "character", na = c("", ".")),
               pe = import_spec(VISITREP = "character", na = c("", ".")))
  
  
  libname(dat, file.path(base_path, "CRF"), "sas7bdat", import_specs = lst)
  
  # dat$dm  
  # dat$pe
   
  expect_equal(class(dat$dm$VISITREP), "character")
  expect_equal(class(dat$dm$PAGEREP), "logical")
  expect_equal(class(dat$pe$VISITREP), "character")
  expect_equal(class(dat$dm$PAGEREP), "logical")
  
})

test_that("dm and pe multiple import_spec col_types work for sas7bdat.", {
  
  lst <- specs(na = c("", "."), trim_ws = TRUE,
               dm = import_spec(VISITREP = "character",
                                PAGEREP = "character"),
               pe = import_spec(PAGEREP = "character",
                                VISITREP = "numeric",
                                DERMRES = "logical", 
                                CARES = "integer"))
  
  
  libname(dat, file.path(base_path, "CRF"), "sas7bdat", import_specs = lst)
  
  # dat$dm  
  # dat$pe
  # View(dat$pe)

  expect_equal(class(dat$dm$VISITREP), "character")
  expect_equal(class(dat$dm$PAGEREP), "character")
  expect_equal(class(dat$dm$BIRTHDD), "numeric")
  expect_equal(class(dat$pe$VISITREP), "numeric")
  expect_equal(class(dat$pe$PAGEREP), "character")
  expect_equal(class(dat$pe$CARES), "integer")
  expect_equal(class(dat$pe$DERMRES), "logical")
  
})

test_that("lab import_spec with dates works for sas7bdat.", {
  
  
  libname(dat, base_path, "sas7bdat")
  
 # 
 # labels(dat$demo_studya)  
 # unclass(dat$demo_studya)
 # 
 # library(haven)
 # nl <- read_sas(file.path(base_path, "demo_studya.sas7bdat"))
 # labels(nl)
   
  
  expect_equal(attr(dat$demo_studya$screendate, "label"), "Date of Screening")


})

test_that("print function works as expected.", {
  
  is1 <- import_spec(col1 = "character", col2 = "integer",
                     na = c("NA", "-"),
                     trim_ws = FALSE)
  
  is2 <- import_spec(col1 = "numeric", col2 = "date:%d%m%Y",
                     na = c(" ", ""),
                     trim_ws = TRUE)
  spcs <- specs(na = c("NA", "-", " ", ""),
                trim_ws = TRUE, AB = is1, AC = is2)
  
  
  spcs
  
  
  expect_equal(TRUE, TRUE)
  
  
})

context("Libname Tests")

base_path <- "c:\\packages\\libr\\tests\\testthat\\data"

base_path <- "./data"

test_that("lib1: libname() function works as expected with csv.", {

  libname(dat, base_path, engine = "csv")

  expect_equal(class(dat)[[1]], "lib")
  expect_equal(length(dat), 2)
  expect_equal(nrow(dat[[1]]), 10)
  expect_equal(ncol(dat[[1]]), 9)
  expect_equal(nrow(dat[[2]]), 2)
  expect_equal(ncol(dat[[2]]), 9)
})


test_that("lib2: libname() and quiet parameter works as expected with csv.", {

  libname(dat, base_path, engine = "csv", quiet = TRUE)

  expect_equal(class(dat)[[1]], "lib")
  expect_equal(length(dat), 2)
  expect_equal(nrow(dat[[1]]), 10)
  expect_equal(ncol(dat[[1]]), 9)
  expect_equal(nrow(dat[[2]]), 2)
  expect_equal(ncol(dat[[2]]), 9)
})

libname(dat, "C:/packages/Testing/incyte/Vicky", engine = "csv")

test_that("lib3: libname() function works as expected with rds", {

  libname(dat, base_path, engine = "rds")


  expect_equal(class(dat)[[1]], "lib")
  expect_equal(length(dat), 2)
  expect_equal(nrow(dat[[1]]), 10)
  expect_equal(ncol(dat[[1]]), 9)
  expect_equal(nrow(dat[[2]]), 2)
  expect_equal(ncol(dat[[2]]), 9)
})

test_that("lib4: libname() function works as expected with rdata", {
  
  
  libname(dat, base_path, engine = "Rdata")
  
  expect_equal(class(dat)[[1]], "lib")
  expect_equal(length(dat), 2)
  expect_equal(nrow(dat[[1]]), 10)
  expect_equal(ncol(dat[[1]]), 9)
  expect_equal(nrow(dat[[2]]), 2)
  expect_equal(ncol(dat[[2]]), 9)
})


test_that("lib5: libname() function works as expected with xls", {

  libname(dat, base_path, engine = "xls")


  expect_equal(class(dat)[[1]], "lib")
  expect_equal(length(dat), 2)
  expect_equal(nrow(dat[[1]]), 10)
  expect_equal(ncol(dat[[1]]), 9)
  expect_equal(nrow(dat[[2]]), 2)
  expect_equal(ncol(dat[[2]]), 9)
})

test_that("lib6: libname() function works as expected with xlsx", {

  libname(dat, base_path, engine = "xlsx")

  expect_equal(class(dat)[[1]], "lib")
  expect_equal(length(dat), 2)
  expect_equal(nrow(dat[[1]]), 10)
  expect_equal(ncol(dat[[1]]), 9)
  expect_equal(nrow(dat[[2]]), 2)
  expect_equal(ncol(dat[[2]]), 9)
})

test_that("lib7: libname() function works as expected with sas7bdat", {

  libname(dat, base_path, engine = "sas7bdat")

  expect_equal(class(dat)[[1]], "lib")
  expect_equal(length(dat), 2)
  expect_equal(nrow(dat[[1]]), 10)
  expect_equal(ncol(dat[[1]]), 9)
  expect_equal(nrow(dat[[2]]), 2)
  expect_equal(ncol(dat[[2]]), 9)
})

test_that("lib8: libname() function works as expected with dbf", {

  tmp <- tempdir()
  libname(dat, tmp, "dbf")

  lib_add(dat, mtcars)

  libname(dat2, tmp, "dbf")


  expect_equal(length(dat2), 1)
  expect_equal(nrow(dat2[[1]]), 32)
  expect_equal(ncol(dat2[[1]]), 11)

  lib_delete(dat)
  lib_delete(dat2)
})

test_that("lib9: libname() function works as expected with xpt", {

  tmp <- tempdir()
  libname(dat, tmp, "xpt")

  lib_add(dat, mtcars)

  libname(dat2, tmp, "xpt")


  expect_equal(length(dat2), 1)
  expect_equal(nrow(dat2[[1]]), 32)
  expect_equal(ncol(dat2[[1]]), 11)

  lib_delete(dat)
  lib_delete(dat2)
})


test_that("lib10: libname() parameter checks work as expected.", {

  expect_error(libname(sam, engine = NULL))
  expect_error(libname(sam, engine = c("sas7bdat", "rds")))
  expect_error(libname(sam, engine = "rds", import_specs = "fork"))
  expect_error(libname(sam, engine = "fork"))


})




test_that("lib11: libname() function works as expected with new directory", {

  fp <- file.path(tempdir(), "fork")

  libname(fork, fp)

  expect_equal(file.exists(fp), TRUE)

  if (file.exists(fp))
    unlink(fp, recursive = TRUE)

})


test_that("lib12: libname() function works as expected within a function.", {

  libname(dat, tempdir())

  lib_load(dat)

  dat.cars <- mtcars
  dat.iris <- iris

  lib_unload(dat)

  expect_equal(length(dat), 2)


})

test_that("lib13: libname() function works as expected within multiple functions.", {

  libname(dat, base_path, "csv")


  func1 <- function() {
    libname(dat, tempdir())

    lib_add(dat, mtcars)

    ret <- names(dat)

    lib_delete(dat)

    return(ret)
  }


  func2 <- function() {

    alt <- file.path(tempdir(), "data2")
    libname(dat, alt)

    lib_add(dat, iris, beaver1)

    ret <- names(dat)


    lib_delete(dat)

    return(ret)
  }

  res1 <- func1()
  res2 <- func2()


  expect_equal(names(dat), c("demo_studya", "demo_studyb"))
  expect_equal(res1, c("mtcars"))
  expect_equal(res2, c("iris", "beaver1"))
})

test_that("lib14: libname() function works as expected with nested functions.", {

  libname(dat, base_path, "csv")


  func1 <- function() {
    libname(dat, tempdir())

    lib_add(dat, mtcars)

    ret <- names(dat)

    lib_delete(dat)

    return(ret)
  }

  func2 <- function() {

    alt <- file.path(tempdir(), "data2")
    libname(dat, alt)

    lib_add(dat, iris, beaver1)

    ret <- list()
    ret[["func2"]] <- names(dat)
    ret[["func1"]] <- func1()

    lib_delete(dat)

    return(ret)
  }

  res <- func2()

  expect_equal(names(dat), c("demo_studya", "demo_studyb"))
  expect_equal(res[["func1"]], c("mtcars"))
  expect_equal(res[["func2"]], c("iris", "beaver1"))
})

test_that("lib15: libname() function works as expected with filter", {

  libname(dat, file.path( base_path, "SDTM"),
          engine = "sas7bdat", filter = c("ae", "dm", "lb", "vs"))

  d <- lib_info(dat)[["Name"]]

  expect_equal(as.character(d), c("ae", "dm", "lb", "vs"))

  libname(dat, file.path( base_path, "SDTM"),
          engine = "sas7bdat", filter = c("*e"))

  d <- lib_info(dat)[["Name"]]

  expect_equal(as.character(d), c("ae", "ie", "pe"))

  libname(dat, file.path( base_path, "SDTM"),
          engine = "sas7bdat", filter = c("d*", "ex", "qs"))

  d <- lib_info(dat)[["Name"]]

  expect_equal(all(d %in% c("da", "dm", "ds", "ds_ihor", "ex", "qs")), TRUE)
})

test_that("lib16: libname()  works as expected with basic operations.", {


  libname(spork, file.path( base_path, "SDTM"),
          engine = "sas7bdat", filter = c("ae", "dm", "lb", "vs"))

  expect_equal("spork" %in% ls(), TRUE)

  lib_load(spork)

  expect_equal("spork.ae" %in% ls(), TRUE)

  lib_unload(spork)

  expect_equal("spork.ae" %in% ls(), FALSE)


  rm("spork")



})


test_that("lib17: libname() standard_eval parameter works as expected with basic operations.", {

  myvar <- "fork"


  libname(myvar, file.path( base_path, "SDTM"),
          engine = "sas7bdat", filter = c("ae", "dm", "lb", "vs"),
          standard_eval = TRUE)

  expect_equal("fork" %in% ls(), TRUE)

  lib_load(myvar)

  expect_equal("fork.ae" %in% ls(), TRUE)

  lib_unload(myvar)

  expect_equal("fork.ae" %in% ls(), FALSE)

  rm("myvar", "fork")


})


test_that("lib18: libname() standard_eval parameter works as expected with all operations.", {

  myvar1 <- "bork1"
  myvar2 <- "bork2"


  libname(myvar1, file.path( base_path, "SDTM"),
          engine = "csv", filter = c("ae", "dm", "lb", "vs"),
          standard_eval = TRUE)


  expect_equal(myvar1 %in% ls(), TRUE)

  lib_info(myvar1)
  lib_path(myvar1)
  lib_size(myvar1)

  lib_load(myvar1)

  expect_equal("bork1.AE" %in% ls(), TRUE)

  lib_unload(myvar1)

  expect_equal("bork1.AE" %in% ls(), FALSE)

  lib_copy(myvar1, myvar2, paste0(base_path, "2"), standard_eval = TRUE)

  expect_equal(nrow(lib_info(myvar2)), 4)
  lib_path(myvar2)
  lib_size(myvar2)

  lib_load(myvar2)

  expect_equal("bork2.AE" %in% ls(), TRUE)


  bork2.mtcars <- mtcars


  expect_equal(nrow(lib_info(myvar2)), 4)


  lib_sync(myvar2)

  expect_equal(nrow(lib_info(myvar2)), 5)


  lib_write(myvar2)
  lib_info(myvar2)
  lib_remove(myvar2, "mtcars")

  expect_equal(nrow(lib_info(myvar2)), 4)

  lib_unload(myvar2)

  expect_equal("bork2.AE" %in% ls(), FALSE)


  lib_add(myvar2, mtcars)

  expect_equal("mtcars" %in% lib_info(myvar2)[[1]], TRUE)

  lib_replace(myvar2, mtcars[1:10, 1:5], name = "mtcars")

  expect_equal(nrow(lib_info(myvar2)), 5)

  lib_delete(myvar2)

  expect_equal(myvar2 %in% ls(), FALSE)

  rm("bork1", "myvar1", "myvar2")



})


test_that("lib19: library parameter checks work as expected.", {
  fork <- "bork"
  f <- "fork"

  expect_error(lib_load(f))
  expect_error(lib_unload(f))
  expect_error(lib_add(f))
  expect_error(lib_replace(f))
  expect_error(lib_remove(f))
  expect_error(lib_write(f))
  expect_error(lib_sync(f))
  expect_error(lib_copy(f))
  expect_error(lib_delete(f))
  expect_error(lib_path(f))
  expect_error(lib_size(f))
  expect_error(lib_info(f))


})

test_that("lib20: lib_export() function works as expected.", {
  
  libname(dat, base_path, engine = "csv")
  
  pth <- paste0(base_path, "2")
  
  lib_export(dat, dat2, pth, "rdata")
  
  expect_equal(length(dat2), 2)
  
  # Clean up
  lib_delete(dat2)
  
  
})

test_that("lib21: lib_export() function works as expected with filter.", {
  
  libname(dat, base_path, engine = "csv")
  
  pth <- paste0(base_path, "2")
  
  lib_export(dat, dat2, pth, "rdata", filter = "*b")
  
  expect_equal(length(dat2), 1)
  
  # Clean up
  lib_delete(dat2)
  
  
})

test_that("lib22: lib_export() function works as expected with standard_eval.", {
  
  libname(dat, base_path, engine = "csv")
  
  pth <- paste0(base_path, "2")
  
  lib_export(dat, "dat3", pth, "rdata", standard_eval = TRUE)
  
  expect_equal(length(dat3), 2)
  
  # Clean up
  lib_delete(dat3)
  
  
})

test_that("lib23: libname works with rda files", {
  
  libname(dat, base_path, engine = "rda")
  
  lib_load(dat)
  
  expect_equal(length(dat), 2)
  
  
  res1 <- lib_info(dat)
  
  expect_equal(res1[[1, "Extension"]], "rda")
  
  pth2 <- paste0(base_path, "2")
  
  libname(dat2, pth2, engine = "rda")  
  
  lib_add(dat2, mtcars)
  
  
  res2 <- lib_info(dat2)
  
  expect_equal(res2[[1, "Extension"]], "rda")
  
  
  lib_copy(dat, dat3, lib_path(dat2))
  
  res3 <- lib_info(dat3)
  
  expect_equal(nrow(res3), 2)
  
  
  
  lib_remove(dat3, name = "demo_studya")
  
  res4 <- lib_info(dat3)
  
  
  expect_equal(nrow(res4), 1)
  
  

  lib_delete(dat2)  
  lib_delete(dat3)
  
  

  
  
  
})


test_that("lib24: lib_export() creates new library.", {
  
  libname(dat, base_path, "xpt", filter = "AD*")
  
  pth2 <- paste0(base_path, "2")
  
  lib_export(dat, dat2, pth2, "rda")
  
  res <- lib_info(dat2)
  
  expect_equal(nrow(res), 2)  
  expect_equal(res[[1, 2]], "rda")
  
  lib_delete(dat2)
  
})


test_that("lib25: libname() function works as expected with rds", {
  
  libname(dat, base_path, engine = "rds", where = expression(sex == 'F'))
  
  # dat$demo_studya
  # dat$demo_studyb
  
  expect_equal(class(dat)[[1]], "lib")
  expect_equal(length(dat), 2)
  expect_equal(nrow(dat[[1]]), 3)
  expect_equal(ncol(dat[[1]]), 9)
  expect_equal(nrow(dat[[2]]), 1)
  expect_equal(ncol(dat[[2]]), 9)
})


test_that("lib26: sas7bdat dates are retained", {
  
  libname(dat, base_path, engine = "sas7bdat")
  
  cls <- class(dat$demo_studyb$dob)
  expect_equal("Date" %in% cls, TRUE)
  
})


test_that("lib27: labels on data are retained after where clause", {
  
  libname(dat, base_path, engine = "sas7bdat")
  
  lbl1 <- labels(dat$demo_studya)
  expect_equal(length(lbl1) > 0, TRUE)
  
  libname(dat2, base_path, engine = "sas7bdat", 
          where = expression(sex == 'F'))
  
  lbl2 <- labels(dat2$demo_studya)
  expect_equal(length(lbl2) > 0, TRUE)

  
})



test_that("lib28: empty dataset works as expected", {
  
  pth <- file.path(base_path, "empty")
  
  libname(testme, pth, "sas7bdat")
  
  
  # No error
  expect_equal(TRUE, TRUE)
  
})


# 
# test_that("lib24: lib_export() creates new library.", {
#   
#   v1 <- c(P1 = 10, P2 = 20, P3 = 30)
#   
#   saveRDS(v1, "C:/packages/libr/tests/testthat/data/vect.rds")
#   
#   libname(testme, base_path, "rds")
#   
# 
# })
